import * as _openid4vc_oauth2 from '@openid4vc/oauth2';
import { PreAuthorizedCodeGrantIdentifier, AuthorizationCodeGrantIdentifier, AuthorizationServerMetadata, ResourceRequestResponseOk, ResourceRequestResponseNotOk, CallbackContext, RequestDpopOptions, JwtSigner, CreateAuthorizationRequestUrlOptions, CreatePkceReturn, RetrievePreAuthorizedCodeAccessTokenOptions, RetrieveAuthorizationCodeAccessTokenOptions, preAuthorizedCodeGrantIdentifier, authorizationCodeGrantIdentifier } from '@openid4vc/oauth2';
import * as z from 'zod';
import z__default from 'zod';
import { InferOutputUnion, Fetch } from '@openid4vc/utils';
export { Oid4vcTsConfig, getGlobalConfig, setGlobalConfig } from '@openid4vc/utils';

declare const zTxCode: z__default.ZodObject<{
    input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
    length: z__default.ZodOptional<z__default.ZodNumber>;
    description: z__default.ZodOptional<z__default.ZodString>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
    length: z__default.ZodOptional<z__default.ZodNumber>;
    description: z__default.ZodOptional<z__default.ZodString>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
    length: z__default.ZodOptional<z__default.ZodNumber>;
    description: z__default.ZodOptional<z__default.ZodString>;
}, z__default.ZodTypeAny, "passthrough">>;
type CredentialOfferPreAuthorizedCodeGrantTxCode = z__default.input<typeof zTxCode>;
declare const zCredentialOfferGrants: z__default.ZodObject<{
    authorization_code: z__default.ZodOptional<z__default.ZodObject<{
        issuer_state: z__default.ZodOptional<z__default.ZodString>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        issuer_state: z__default.ZodOptional<z__default.ZodString>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        issuer_state: z__default.ZodOptional<z__default.ZodString>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
        'pre-authorized_code': z__default.ZodString;
        tx_code: z__default.ZodOptional<z__default.ZodObject<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        'pre-authorized_code': z__default.ZodString;
        tx_code: z__default.ZodOptional<z__default.ZodObject<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        'pre-authorized_code': z__default.ZodString;
        tx_code: z__default.ZodOptional<z__default.ZodObject<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    authorization_code: z__default.ZodOptional<z__default.ZodObject<{
        issuer_state: z__default.ZodOptional<z__default.ZodString>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        issuer_state: z__default.ZodOptional<z__default.ZodString>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        issuer_state: z__default.ZodOptional<z__default.ZodString>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
        'pre-authorized_code': z__default.ZodString;
        tx_code: z__default.ZodOptional<z__default.ZodObject<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        'pre-authorized_code': z__default.ZodString;
        tx_code: z__default.ZodOptional<z__default.ZodObject<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        'pre-authorized_code': z__default.ZodString;
        tx_code: z__default.ZodOptional<z__default.ZodObject<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    authorization_code: z__default.ZodOptional<z__default.ZodObject<{
        issuer_state: z__default.ZodOptional<z__default.ZodString>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        issuer_state: z__default.ZodOptional<z__default.ZodString>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        issuer_state: z__default.ZodOptional<z__default.ZodString>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
        'pre-authorized_code': z__default.ZodString;
        tx_code: z__default.ZodOptional<z__default.ZodObject<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        'pre-authorized_code': z__default.ZodString;
        tx_code: z__default.ZodOptional<z__default.ZodObject<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        'pre-authorized_code': z__default.ZodString;
        tx_code: z__default.ZodOptional<z__default.ZodObject<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
            length: z__default.ZodOptional<z__default.ZodNumber>;
            description: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>;
type CredentialOfferGrants = z__default.input<typeof zCredentialOfferGrants>;
type CredentialOfferPreAuthorizedCodeGrant = CredentialOfferGrants[PreAuthorizedCodeGrantIdentifier];
type CredenialOfferAuthorizationCodeGrant = CredentialOfferGrants[AuthorizationCodeGrantIdentifier];
declare const zCredentialOfferObjectDraft14: z__default.ZodObject<{
    credential_issuer: z__default.ZodEffects<z__default.ZodString, string, string>;
    credential_configuration_ids: z__default.ZodArray<z__default.ZodString, "many">;
    grants: z__default.ZodOptional<z__default.ZodObject<{
        authorization_code: z__default.ZodOptional<z__default.ZodObject<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        authorization_code: z__default.ZodOptional<z__default.ZodObject<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        authorization_code: z__default.ZodOptional<z__default.ZodObject<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    credential_issuer: z__default.ZodEffects<z__default.ZodString, string, string>;
    credential_configuration_ids: z__default.ZodArray<z__default.ZodString, "many">;
    grants: z__default.ZodOptional<z__default.ZodObject<{
        authorization_code: z__default.ZodOptional<z__default.ZodObject<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        authorization_code: z__default.ZodOptional<z__default.ZodObject<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        authorization_code: z__default.ZodOptional<z__default.ZodObject<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    credential_issuer: z__default.ZodEffects<z__default.ZodString, string, string>;
    credential_configuration_ids: z__default.ZodArray<z__default.ZodString, "many">;
    grants: z__default.ZodOptional<z__default.ZodObject<{
        authorization_code: z__default.ZodOptional<z__default.ZodObject<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        authorization_code: z__default.ZodOptional<z__default.ZodObject<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        authorization_code: z__default.ZodOptional<z__default.ZodObject<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            issuer_state: z__default.ZodOptional<z__default.ZodString>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        "urn:ietf:params:oauth:grant-type:pre-authorized_code": z__default.ZodOptional<z__default.ZodObject<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            'pre-authorized_code': z__default.ZodString;
            tx_code: z__default.ZodOptional<z__default.ZodObject<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                input_mode: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodLiteral<"numeric">, z__default.ZodLiteral<"text">]>>;
                length: z__default.ZodOptional<z__default.ZodNumber>;
                description: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            authorization_server: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>;
type CredentialOfferObject = z__default.input<typeof zCredentialOfferObjectDraft14>;

declare const zCredentialRequestProof: z__default.ZodUnion<[z__default.ZodObject<{
    proof_type: z__default.ZodString;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    proof_type: z__default.ZodString;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    proof_type: z__default.ZodString;
}, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
    proof_type: z__default.ZodLiteral<"jwt">;
    jwt: z__default.ZodString;
}, "strip", z__default.ZodTypeAny, {
    jwt: string;
    proof_type: "jwt";
}, {
    jwt: string;
    proof_type: "jwt";
}>, z__default.ZodObject<{
    proof_type: z__default.ZodLiteral<"attestation">;
    attestation: z__default.ZodString;
}, "strip", z__default.ZodTypeAny, {
    attestation: string;
    proof_type: "attestation";
}, {
    attestation: string;
    proof_type: "attestation";
}>]>]>;
declare const zCredentialRequestProofs: z__default.ZodObject<{
    jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, "strip", z__default.ZodTypeAny, {
    jwt?: string[] | undefined;
    attestation?: string[] | undefined;
}, {
    jwt?: string[] | undefined;
    attestation?: string[] | undefined;
}>;
type CredentialRequestProof = z__default.infer<typeof zCredentialRequestProof>;
type CredentialRequestProofsFormatSpecific = z__default.infer<typeof zCredentialRequestProofs>;
type CredentialRequestProofs = z__default.infer<typeof zCredentialRequestProofs>;
declare const zCredentialRequestCommon: z__default.ZodEffects<z__default.ZodObject<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>;

declare const allCredentialRequestFormats: readonly [z__default.ZodObject<{
    format: z__default.ZodLiteral<"vc+sd-jwt">;
    vct: z__default.ZodString;
    claims: z__default.ZodOptional<z__default.ZodObject<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, "strip", z__default.ZodTypeAny, {
    format: "vc+sd-jwt";
    vct: string;
    claims?: z__default.objectOutputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
}, {
    format: "vc+sd-jwt";
    vct: string;
    claims?: z__default.objectInputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
}>, z__default.ZodObject<{
    format: z__default.ZodLiteral<"mso_mdoc">;
    doctype: z__default.ZodString;
    claims: z__default.ZodOptional<z__default.ZodObject<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, "strip", z__default.ZodTypeAny, {
    format: "mso_mdoc";
    doctype: string;
    claims?: z__default.objectOutputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
}, {
    format: "mso_mdoc";
    doctype: string;
    claims?: z__default.objectInputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
}>, z__default.ZodObject<{
    format: z__default.ZodLiteral<"ldp_vc">;
    credential_definition: z__default.ZodObject<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">>;
}, "strip", z__default.ZodTypeAny, {
    format: "ldp_vc";
    credential_definition: {
        type: string[];
        '@context': string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
}, {
    format: "ldp_vc";
    credential_definition: {
        type: string[];
        '@context': string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
}>, z__default.ZodObject<{
    format: z__default.ZodLiteral<"jwt_vc_json-ld">;
    credential_definition: z__default.ZodObject<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">>;
}, "strip", z__default.ZodTypeAny, {
    format: "jwt_vc_json-ld";
    credential_definition: {
        type: string[];
        '@context': string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
}, {
    format: "jwt_vc_json-ld";
    credential_definition: {
        type: string[];
        '@context': string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
}>, z__default.ZodObject<{
    format: z__default.ZodLiteral<"jwt_vc_json">;
    credential_definition: z__default.ZodObject<{
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">>;
}, "strip", z__default.ZodTypeAny, {
    format: "jwt_vc_json";
    credential_definition: {
        type: string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
}, {
    format: "jwt_vc_json";
    credential_definition: {
        type: string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
}>];
declare const zCredentialRequestDraft14: z__default.ZodUnion<[z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodEffects<z__default.ZodObject<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>, z__default.ZodObject<{
    format: z__default.ZodString;
    credential_identifier: z__default.ZodOptional<z__default.ZodNever>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    format: z__default.ZodString;
    credential_identifier: z__default.ZodOptional<z__default.ZodNever>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    format: z__default.ZodString;
    credential_identifier: z__default.ZodOptional<z__default.ZodNever>;
}, z__default.ZodTypeAny, "passthrough">>>, {
    proof?: {
        attestation: string;
        proof_type: "attestation";
    } | {
        jwt: string;
        proof_type: "jwt";
    } | z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
    proofs?: (Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }) | undefined;
    credential_response_encryption?: z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
} & {
    [k: string]: unknown;
} & {
    format: string;
    credential_identifier?: undefined;
}, {
    proof?: {
        attestation: string;
        proof_type: "attestation";
    } | {
        jwt: string;
        proof_type: "jwt";
    } | z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
    proofs?: (Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }) | undefined;
    credential_response_encryption?: z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
} & {
    [k: string]: unknown;
} & {
    format: string;
    credential_identifier?: undefined;
}>, z__default.ZodIntersection<z__default.ZodEffects<z__default.ZodObject<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    proof: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodObject<{
        proof_type: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        proof_type: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.ZodDiscriminatedUnion<"proof_type", readonly [z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"jwt">;
        jwt: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        jwt: string;
        proof_type: "jwt";
    }, {
        jwt: string;
        proof_type: "jwt";
    }>, z__default.ZodObject<{
        proof_type: z__default.ZodLiteral<"attestation">;
        attestation: z__default.ZodString;
    }, "strip", z__default.ZodTypeAny, {
        attestation: string;
        proof_type: "attestation";
    }, {
        attestation: string;
        proof_type: "attestation";
    }>]>]>>;
    proofs: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodIntersection<z__default.ZodRecord<z__default.ZodString, z__default.ZodArray<z__default.ZodUnknown, "many">>, z__default.ZodObject<{
        jwt: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        attestation: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    }, "strip", z__default.ZodTypeAny, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, Record<string, unknown[]> & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>;
        alg: z__default.ZodString;
        enc: z__default.ZodString;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>, z__default.ZodObject<{
    credential_identifier: z__default.ZodString;
    format: z__default.ZodOptional<z__default.ZodNever>;
}, "strip", z__default.ZodTypeAny, {
    credential_identifier: string;
    format?: undefined;
}, {
    credential_identifier: string;
    format?: undefined;
}>>]>;
type CredentialRequestCommon = z__default.infer<typeof zCredentialRequestCommon>;
type CredentialRequestFormatSpecific = InferOutputUnion<typeof allCredentialRequestFormats>;
type CredentialRequestWithFormats = CredentialRequestCommon & CredentialRequestFormatSpecific;
type CredentialRequest = z__default.infer<typeof zCredentialRequestDraft14>;

interface ParseCredentialRequestOptions {
    credentialRequest: Record<string, unknown>;
}
interface ParseCredentialRequestReturn {
    /**
     * If the request was for a `format` that is known to this library it will have the
     * format specific data defined here. Will not be defined if the request is for an unknown format,
     * or if `credential_identifier` is used.
     */
    format?: CredentialRequestFormatSpecific;
    /**
     * If the request contains `proof` or `proofs` with a `proof_type` that is known to this
     * library it will have the proof type specific data defined here. Will not be defined
     * if the `proof_type` is not known or no `proof` or `proofs` were included.
     *
     * The `proof` property is parsed to the new proofs structure and the entries will
     * always only have a single entry in this case.
     *
     * NOTE: this value being `undefined` does NOT mean there were no proofs.
     * It means that either there were no proofs, or that the proof format is not
     * known to this library
     */
    proofs?: CredentialRequestProofsFormatSpecific;
    /**
     * If authorization details were used a `credential_identifier` will be included
     * in the request. Will not be defined if `format` is defined.
     */
    credentialIdentifier?: string;
    /**
     * The validated credential request. If both `format` and `credentialIdentifier` are
     * undefined you can still handle the request by using this object directly.
     */
    credentialRequest: CredentialRequest;
}

declare enum Oid4vciDraftVersion {
    Draft14 = "Draft14",
    Draft11 = "Draft11"
}

declare const zCredentialConfigurationSupportedCommon: z__default.ZodObject<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">>;

declare const allCredentialIssuerMetadataFormats: readonly [z__default.ZodObject<{
    vct: z__default.ZodString;
    format: z__default.ZodLiteral<"vc+sd-jwt">;
    claims: z__default.ZodOptional<z__default.ZodObject<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    order: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, "strip", z__default.ZodTypeAny, {
    format: "vc+sd-jwt";
    vct: string;
    claims?: z__default.objectOutputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
    order?: string[] | undefined;
}, {
    format: "vc+sd-jwt";
    vct: string;
    claims?: z__default.objectInputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
    order?: string[] | undefined;
}>, z__default.ZodObject<{
    format: z__default.ZodLiteral<"mso_mdoc">;
    doctype: z__default.ZodString;
    claims: z__default.ZodOptional<z__default.ZodObject<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    order: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, "strip", z__default.ZodTypeAny, {
    format: "mso_mdoc";
    doctype: string;
    claims?: z__default.objectOutputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
    order?: string[] | undefined;
}, {
    format: "mso_mdoc";
    doctype: string;
    claims?: z__default.objectInputType<{
        mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
        value_type: z__default.ZodOptional<z__default.ZodString>;
        display: z__default.ZodOptional<z__default.ZodObject<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodOptional<z__default.ZodString>;
            locale: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough"> | undefined;
    order?: string[] | undefined;
}>, z__default.ZodObject<{
    format: z__default.ZodLiteral<"jwt_vc_json-ld">;
    credential_definition: z__default.ZodObject<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">>;
    order: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, "strip", z__default.ZodTypeAny, {
    format: "jwt_vc_json-ld";
    credential_definition: {
        type: string[];
        '@context': string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
    order?: string[] | undefined;
}, {
    format: "jwt_vc_json-ld";
    credential_definition: {
        type: string[];
        '@context': string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
    order?: string[] | undefined;
}>, z__default.ZodObject<{
    format: z__default.ZodLiteral<"ldp_vc">;
    credential_definition: z__default.ZodObject<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        '@context': z__default.ZodArray<z__default.ZodString, "many">;
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">>;
    order: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, "strip", z__default.ZodTypeAny, {
    format: "ldp_vc";
    credential_definition: {
        type: string[];
        '@context': string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
    order?: string[] | undefined;
}, {
    format: "ldp_vc";
    credential_definition: {
        type: string[];
        '@context': string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
    order?: string[] | undefined;
}>, z__default.ZodObject<{
    format: z__default.ZodLiteral<"jwt_vc_json">;
    credential_definition: z__default.ZodObject<{
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        type: z__default.ZodArray<z__default.ZodString, "many">;
        credentialSubject: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodUnion<[z__default.ZodArray<z__default.ZodAny, "many">, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>, z__default.ZodObject<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>]>>>;
    }, z__default.ZodTypeAny, "passthrough">>;
    order: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, "strip", z__default.ZodTypeAny, {
    format: "jwt_vc_json";
    credential_definition: {
        type: string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
    order?: string[] | undefined;
}, {
    format: "jwt_vc_json";
    credential_definition: {
        type: string[];
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectInputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
    } & {
        [k: string]: unknown;
    };
    order?: string[] | undefined;
}>];
declare const zCredentialConfigurationSupportedWithFormats: z__default.ZodEffects<z__default.ZodObject<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">>;
type CredentialConfigurationSupportedCommon = z__default.infer<typeof zCredentialConfigurationSupportedCommon>;
type CredentialConfigurationSupportedFormatSpecific = InferOutputUnion<typeof allCredentialIssuerMetadataFormats>;
type CredentialConfigurationSupportedWithFormats = CredentialConfigurationSupportedFormatSpecific & CredentialConfigurationSupportedCommon;
type CredentialConfigurationsSupportedWithFormats = Record<string, CredentialConfigurationSupportedWithFormats>;
type CredentialConfigurationSupported = z__default.infer<typeof zCredentialConfigurationSupportedWithFormats>;
type CredentialConfigurationsSupported = Record<string, CredentialConfigurationSupported>;
declare const zCredentialIssuerMetadataDisplayEntry: z__default.ZodObject<{
    name: z__default.ZodOptional<z__default.ZodString>;
    locale: z__default.ZodOptional<z__default.ZodString>;
    logo: z__default.ZodOptional<z__default.ZodObject<{
        uri: z__default.ZodOptional<z__default.ZodString>;
        alt_text: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        uri: z__default.ZodOptional<z__default.ZodString>;
        alt_text: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        uri: z__default.ZodOptional<z__default.ZodString>;
        alt_text: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    name: z__default.ZodOptional<z__default.ZodString>;
    locale: z__default.ZodOptional<z__default.ZodString>;
    logo: z__default.ZodOptional<z__default.ZodObject<{
        uri: z__default.ZodOptional<z__default.ZodString>;
        alt_text: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        uri: z__default.ZodOptional<z__default.ZodString>;
        alt_text: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        uri: z__default.ZodOptional<z__default.ZodString>;
        alt_text: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    name: z__default.ZodOptional<z__default.ZodString>;
    locale: z__default.ZodOptional<z__default.ZodString>;
    logo: z__default.ZodOptional<z__default.ZodObject<{
        uri: z__default.ZodOptional<z__default.ZodString>;
        alt_text: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        uri: z__default.ZodOptional<z__default.ZodString>;
        alt_text: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        uri: z__default.ZodOptional<z__default.ZodString>;
        alt_text: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>;
type CredentialIssuerMetadataDisplayEntry = z__default.infer<typeof zCredentialIssuerMetadataDisplayEntry>;
type CredentialIssuerMetadata = z__default.infer<typeof zCredentialIssuerMetadataDraft14>;
declare const zCredentialIssuerMetadataDraft14: z__default.ZodObject<{
    credential_issuer: z__default.ZodEffects<z__default.ZodString, string, string>;
    authorization_servers: z__default.ZodOptional<z__default.ZodArray<z__default.ZodEffects<z__default.ZodString, string, string>, "many">>;
    credential_endpoint: z__default.ZodEffects<z__default.ZodString, string, string>;
    deferred_credential_endpoint: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    notification_endpoint: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    nonce_endpoint: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        enc_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        encryption_required: z__default.ZodBoolean;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        enc_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        encryption_required: z__default.ZodBoolean;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        enc_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        encryption_required: z__default.ZodBoolean;
    }, z__default.ZodTypeAny, "passthrough">>>;
    batch_credential_issuance: z__default.ZodOptional<z__default.ZodObject<{
        batch_size: z__default.ZodNumber;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        batch_size: z__default.ZodNumber;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        batch_size: z__default.ZodNumber;
    }, z__default.ZodTypeAny, "passthrough">>>;
    signed_metadata: z__default.ZodOptional<z__default.ZodString>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodOptional<z__default.ZodString>;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodOptional<z__default.ZodString>;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodOptional<z__default.ZodString>;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    credential_configurations_supported: z__default.ZodRecord<z__default.ZodString, z__default.ZodEffects<z__default.ZodObject<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    credential_issuer: z__default.ZodEffects<z__default.ZodString, string, string>;
    authorization_servers: z__default.ZodOptional<z__default.ZodArray<z__default.ZodEffects<z__default.ZodString, string, string>, "many">>;
    credential_endpoint: z__default.ZodEffects<z__default.ZodString, string, string>;
    deferred_credential_endpoint: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    notification_endpoint: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    nonce_endpoint: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        enc_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        encryption_required: z__default.ZodBoolean;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        enc_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        encryption_required: z__default.ZodBoolean;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        enc_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        encryption_required: z__default.ZodBoolean;
    }, z__default.ZodTypeAny, "passthrough">>>;
    batch_credential_issuance: z__default.ZodOptional<z__default.ZodObject<{
        batch_size: z__default.ZodNumber;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        batch_size: z__default.ZodNumber;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        batch_size: z__default.ZodNumber;
    }, z__default.ZodTypeAny, "passthrough">>>;
    signed_metadata: z__default.ZodOptional<z__default.ZodString>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodOptional<z__default.ZodString>;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodOptional<z__default.ZodString>;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodOptional<z__default.ZodString>;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    credential_configurations_supported: z__default.ZodRecord<z__default.ZodString, z__default.ZodEffects<z__default.ZodObject<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    credential_issuer: z__default.ZodEffects<z__default.ZodString, string, string>;
    authorization_servers: z__default.ZodOptional<z__default.ZodArray<z__default.ZodEffects<z__default.ZodString, string, string>, "many">>;
    credential_endpoint: z__default.ZodEffects<z__default.ZodString, string, string>;
    deferred_credential_endpoint: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    notification_endpoint: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    nonce_endpoint: z__default.ZodOptional<z__default.ZodEffects<z__default.ZodString, string, string>>;
    credential_response_encryption: z__default.ZodOptional<z__default.ZodObject<{
        alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        enc_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        encryption_required: z__default.ZodBoolean;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        enc_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        encryption_required: z__default.ZodBoolean;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        enc_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        encryption_required: z__default.ZodBoolean;
    }, z__default.ZodTypeAny, "passthrough">>>;
    batch_credential_issuance: z__default.ZodOptional<z__default.ZodObject<{
        batch_size: z__default.ZodNumber;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        batch_size: z__default.ZodNumber;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        batch_size: z__default.ZodNumber;
    }, z__default.ZodTypeAny, "passthrough">>>;
    signed_metadata: z__default.ZodOptional<z__default.ZodString>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodOptional<z__default.ZodString>;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodOptional<z__default.ZodString>;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodOptional<z__default.ZodString>;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    credential_configurations_supported: z__default.ZodRecord<z__default.ZodString, z__default.ZodEffects<z__default.ZodObject<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        format: z__default.ZodString;
        scope: z__default.ZodOptional<z__default.ZodString>;
        cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
        proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
            proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
            key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough">>>;
        }, "strip", z__default.ZodTypeAny, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectOutputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }, {
            proof_signing_alg_values_supported: string[];
            key_attestations_required?: z__default.objectInputType<{
                key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
                user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            }, z__default.ZodTypeAny, "passthrough"> | undefined;
        }>>>;
        display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            name: z__default.ZodString;
            locale: z__default.ZodOptional<z__default.ZodString>;
            logo: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
                alt_text: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            description: z__default.ZodOptional<z__default.ZodString>;
            background_color: z__default.ZodOptional<z__default.ZodString>;
            background_image: z__default.ZodOptional<z__default.ZodObject<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                uri: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>>;
            text_color: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
    }, z__default.ZodTypeAny, "passthrough">>>;
}, z__default.ZodTypeAny, "passthrough">>;
declare const zCredentialConfigurationSupportedDraft11To14: z__default.ZodPipeline<z__default.ZodEffects<z__default.ZodEffects<z__default.ZodObject<{
    id: z__default.ZodOptional<z__default.ZodString>;
    format: z__default.ZodString;
    cryptographic_suites_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    id: z__default.ZodOptional<z__default.ZodString>;
    format: z__default.ZodString;
    cryptographic_suites_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    id: z__default.ZodOptional<z__default.ZodString>;
    format: z__default.ZodString;
    cryptographic_suites_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">>, {
    display?: {
        background_image?: {
            uri: string;
        } | undefined;
        logo?: {
            uri: string;
        } | undefined;
    }[] | undefined;
    credential_signing_alg_values_supported?: string[] | undefined;
    format: string;
}, z__default.objectInputType<{
    id: z__default.ZodOptional<z__default.ZodString>;
    format: z__default.ZodString;
    cryptographic_suites_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">>, {
    credential_definition: {
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
        type: string[];
    };
    format: "jwt_vc_json";
    order?: string[] | undefined;
} | {
    credential_definition: {
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
        '@context': string[];
        type: string[];
    };
    format: "jwt_vc_json-ld";
    order?: string[] | undefined;
} | {
    credential_definition: {
        credentialSubject?: Record<string, any[] | Record<string, any> | z__default.objectOutputType<{
            mandatory: z__default.ZodOptional<z__default.ZodBoolean>;
            value_type: z__default.ZodOptional<z__default.ZodString>;
            display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                name: z__default.ZodOptional<z__default.ZodString>;
                locale: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">> | undefined;
        '@context': string[];
        type: string[];
    };
    format: "ldp_vc";
    order?: string[] | undefined;
} | {
    display?: {
        background_image?: {
            uri: string;
        } | undefined;
        logo?: {
            uri: string;
        } | undefined;
    }[] | undefined;
    credential_signing_alg_values_supported?: string[] | undefined;
    format: string;
}, z__default.objectInputType<{
    id: z__default.ZodOptional<z__default.ZodString>;
    format: z__default.ZodString;
    cryptographic_suites_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        logo: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            url: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">>, z__default.ZodEffects<z__default.ZodObject<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    format: z__default.ZodString;
    scope: z__default.ZodOptional<z__default.ZodString>;
    cryptographic_binding_methods_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    credential_signing_alg_values_supported: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    proof_types_supported: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodUnion<[z__default.ZodLiteral<"jwt">, z__default.ZodLiteral<"attestation">, z__default.ZodString]>, z__default.ZodObject<{
        proof_signing_alg_values_supported: z__default.ZodArray<z__default.ZodString, "many">;
        key_attestations_required: z__default.ZodOptional<z__default.ZodObject<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough">>>;
    }, "strip", z__default.ZodTypeAny, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectOutputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }, {
        proof_signing_alg_values_supported: string[];
        key_attestations_required?: z__default.objectInputType<{
            key_storage: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
            user_authentication: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z__default.ZodString]>, "many">>;
        }, z__default.ZodTypeAny, "passthrough"> | undefined;
    }>>>;
    display: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        name: z__default.ZodString;
        locale: z__default.ZodOptional<z__default.ZodString>;
        logo: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
            alt_text: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        description: z__default.ZodOptional<z__default.ZodString>;
        background_color: z__default.ZodOptional<z__default.ZodString>;
        background_image: z__default.ZodOptional<z__default.ZodObject<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            uri: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        text_color: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>, "many">>;
}, z__default.ZodTypeAny, "passthrough">>>;

interface IssuerMetadataResult {
    originalDraftVersion?: Oid4vciDraftVersion;
    credentialIssuer: CredentialIssuerMetadata;
    authorizationServers: AuthorizationServerMetadata[];
}

declare enum Oauth2ErrorCodes {
    ServerError = "server_error",
    InvalidTarget = "invalid_target",
    InvalidRequest = "invalid_request",
    InvalidToken = "invalid_token",
    InsufficientScope = "insufficient_scope",
    InvalidGrant = "invalid_grant",
    InvalidClient = "invalid_client",
    UnauthorizedClient = "unauthorized_client",
    UnsupportedGrantType = "unsupported_grant_type",
    InvalidScope = "invalid_scope",
    InvalidDpopProof = "invalid_dpop_proof",
    UseDpopNonce = "use_dpop_nonce",
    RedirectToWeb = "redirect_to_web",
    InvalidSession = "invalid_session",
    InsufficientAuthorization = "insufficient_authorization",
    InvalidCredentialRequest = "invalid_credential_request",
    CredentialRequestDenied = "credential_request_denied",
    UnsupportedCredentialType = "unsupported_credential_type",
    UnsupportedCredentialFormat = "unsupported_credential_format",
    InvalidProof = "invalid_proof",
    InvalidNonce = "invalid_nonce",
    InvalidEncryptionParameters = "invalid_encryption_parameters"
}

declare const zCredentialResponse: z__default.ZodEffects<z__default.ZodObject<{
    credential: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>>;
    credentials: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>, "many">>;
    transaction_id: z__default.ZodOptional<z__default.ZodString>;
    c_nonce: z__default.ZodOptional<z__default.ZodString>;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
    notification_id: z__default.ZodOptional<z__default.ZodString>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    credential: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>>;
    credentials: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>, "many">>;
    transaction_id: z__default.ZodOptional<z__default.ZodString>;
    c_nonce: z__default.ZodOptional<z__default.ZodString>;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
    notification_id: z__default.ZodOptional<z__default.ZodString>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    credential: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>>;
    credentials: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>, "many">>;
    transaction_id: z__default.ZodOptional<z__default.ZodString>;
    c_nonce: z__default.ZodOptional<z__default.ZodString>;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
    notification_id: z__default.ZodOptional<z__default.ZodString>;
}, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<{
    credential: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>>;
    credentials: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>, "many">>;
    transaction_id: z__default.ZodOptional<z__default.ZodString>;
    c_nonce: z__default.ZodOptional<z__default.ZodString>;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
    notification_id: z__default.ZodOptional<z__default.ZodString>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    credential: z__default.ZodOptional<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>>;
    credentials: z__default.ZodOptional<z__default.ZodArray<z__default.ZodUnion<[z__default.ZodString, z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>]>, "many">>;
    transaction_id: z__default.ZodOptional<z__default.ZodString>;
    c_nonce: z__default.ZodOptional<z__default.ZodString>;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
    notification_id: z__default.ZodOptional<z__default.ZodString>;
}, z__default.ZodTypeAny, "passthrough">>;
type CredentialResponse = z__default.infer<typeof zCredentialResponse>;
declare const zCredentialErrorResponse: z__default.ZodObject<{
    c_nonce: z__default.ZodOptional<z__default.ZodString>;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
    error: z__default.ZodUnion<[z__default.ZodNativeEnum<typeof Oauth2ErrorCodes>, z__default.ZodString]>;
    error_description: z__default.ZodOptional<z__default.ZodString>;
    error_uri: z__default.ZodOptional<z__default.ZodString>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    c_nonce: z__default.ZodOptional<z__default.ZodString>;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
    error: z__default.ZodUnion<[z__default.ZodNativeEnum<typeof Oauth2ErrorCodes>, z__default.ZodString]>;
    error_description: z__default.ZodOptional<z__default.ZodString>;
    error_uri: z__default.ZodOptional<z__default.ZodString>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    c_nonce: z__default.ZodOptional<z__default.ZodString>;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
    error: z__default.ZodUnion<[z__default.ZodNativeEnum<typeof Oauth2ErrorCodes>, z__default.ZodString]>;
    error_description: z__default.ZodOptional<z__default.ZodString>;
    error_uri: z__default.ZodOptional<z__default.ZodString>;
}, z__default.ZodTypeAny, "passthrough">>;
type CredentialErrorResponse = z__default.infer<typeof zCredentialErrorResponse>;

interface RetrieveCredentialsBaseOptions {
    /**
     * Metadata of the credential issuer and authorization servers.
     */
    issuerMetadata: IssuerMetadataResult;
    /**
     * Callback used in retrieve credentials endpoints
     */
    callbacks: Pick<CallbackContext, 'fetch' | 'generateRandom' | 'hash' | 'signJwt'>;
    /**
     * Access token authorized to retrieve the credential(s)
     */
    accessToken: string;
    /**
     * DPoP options
     */
    dpop?: RequestDpopOptions;
}
interface RetrieveCredentialsWithFormatOptions extends RetrieveCredentialsBaseOptions {
    /**
     * Additional payload to include in the credential request.
     */
    additionalRequestPayload?: Record<string, unknown>;
    /**
     * The format specific payload. Needs to at least include the `format` and other params
     * are determined by the format itself
     */
    formatPayload: CredentialRequestWithFormats;
    proof?: CredentialRequestProof;
    proofs?: CredentialRequestProofs;
}
interface RetrieveCredentialsResponseOk extends ResourceRequestResponseOk {
    /**
     * The successfull validated (in structure, not the actual contents are validated) credential response payload
     */
    credentialResponse: CredentialResponse;
}
interface RetrieveCredentialsResponseNotOk extends ResourceRequestResponseNotOk {
    /**
     * If this is defined it means the response itself was succesfull but the validation of the
     * credential response data structure failed
     */
    credentialResponseResult?: ReturnType<typeof zCredentialResponse.safeParse>;
    /**
     * If this is defined it means the response was JSON and we tried to parse it as
     * a credential error response. It may be successfull or it may not be.
     */
    credentialErrorResponseResult?: ReturnType<typeof zCredentialErrorResponse.safeParse>;
}

interface GetCredentialConfigurationsMatchingRequestFormatOptions {
    requestFormat: CredentialRequestFormatSpecific;
    credentialConfigurations: CredentialConfigurationsSupported;
}
declare function getCredentialConfigurationsMatchingRequestFormat({ requestFormat, credentialConfigurations, }: GetCredentialConfigurationsMatchingRequestFormatOptions): CredentialConfigurationsSupportedWithFormats;

interface Oid4vciErrorOptions {
    cause?: unknown;
}
declare class Oid4vciError extends Error {
    readonly cause?: unknown;
    constructor(message?: string, options?: Oid4vciErrorOptions);
}

declare class Oid4vciRetrieveCredentialsError extends Oid4vciError {
    response: RetrieveCredentialsResponseNotOk;
    constructor(message: string, response: RetrieveCredentialsResponseNotOk, responseText: string);
}

declare const zNotificationEvent: z__default.ZodEnum<["credential_accepted", "credential_failure", "credential_deleted"]>;
type NotificationEvent = z__default.infer<typeof zNotificationEvent>;
declare const zNotificationErrorResponse: z__default.ZodObject<{
    error: z__default.ZodEnum<["invalid_notification_id", "invalid_notification_request"]>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    error: z__default.ZodEnum<["invalid_notification_id", "invalid_notification_request"]>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    error: z__default.ZodEnum<["invalid_notification_id", "invalid_notification_request"]>;
}, z__default.ZodTypeAny, "passthrough">>;
type NotificationErrorResponse = z__default.infer<typeof zNotificationErrorResponse>;

interface SendNotifcationOptions {
    notification: {
        /**
         * Notification id, as returned in the credential response
         */
        notificationId: string;
        /**
         * The notification
         */
        event: NotificationEvent;
        /**
         * Humand readable desription of the event
         */
        eventDescription?: string;
    };
    /**
     * Metadata of the credential issuer and authorization servers.
     */
    issuerMetadata: IssuerMetadataResult;
    /**
     * Callback used in notification endpoint
     */
    callbacks: Pick<CallbackContext, 'fetch' | 'generateRandom' | 'hash' | 'signJwt'>;
    /**
     * Access token authorized to retrieve the credential(s)
     */
    accessToken: string;
    /**
     * DPoP options
     */
    dpop?: RequestDpopOptions;
    /**
     * Additional payload to include in the notification request.
     */
    additionalRequestPayload?: Record<string, unknown>;
}
type SendNotificationResponseOk = ResourceRequestResponseOk;
interface SendNotificationResponseNotOk extends ResourceRequestResponseNotOk {
    /**
     * If this is defined it means the response was JSON and we tried to parse it as
     * a notification error response. It may be successfull or it may not be.
     */
    notificationErrorResponseResult?: ReturnType<typeof zNotificationErrorResponse.safeParse>;
}

declare class Oid4vciSendNotificationError extends Oid4vciError {
    response: SendNotificationResponseNotOk;
    constructor(message: string, response: SendNotificationResponseNotOk);
}

declare const zNonceResponse: z__default.ZodObject<{
    c_nonce: z__default.ZodString;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    c_nonce: z__default.ZodString;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    c_nonce: z__default.ZodString;
    c_nonce_expires_in: z__default.ZodOptional<z__default.ZodNumber>;
}, z__default.ZodTypeAny, "passthrough">>;
type NonceResponse = z__default.infer<typeof zNonceResponse>;

declare const zJwtProofTypeIdentifier: z__default.ZodLiteral<"jwt">;
type JwtProofTypeIdentifier = z__default.infer<typeof zJwtProofTypeIdentifier>;
declare const zCredentialRequestJwtProofTypeHeader: z__default.ZodEffects<z__default.ZodEffects<z__default.ZodObject<z__default.objectUtil.extendShape<{
    alg: z__default.ZodEffects<z__default.ZodString, string, string>;
    typ: z__default.ZodOptional<z__default.ZodString>;
    kid: z__default.ZodOptional<z__default.ZodString>;
    jwk: z__default.ZodOptional<z__default.ZodObject<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    x5c: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    trust_chain: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, {
    key_attestation: z__default.ZodOptional<z__default.ZodString>;
    typ: z__default.ZodLiteral<"openid4vci-proof+jwt">;
}>, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<z__default.objectUtil.extendShape<{
    alg: z__default.ZodEffects<z__default.ZodString, string, string>;
    typ: z__default.ZodOptional<z__default.ZodString>;
    kid: z__default.ZodOptional<z__default.ZodString>;
    jwk: z__default.ZodOptional<z__default.ZodObject<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    x5c: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    trust_chain: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, {
    key_attestation: z__default.ZodOptional<z__default.ZodString>;
    typ: z__default.ZodLiteral<"openid4vci-proof+jwt">;
}>, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<z__default.objectUtil.extendShape<{
    alg: z__default.ZodEffects<z__default.ZodString, string, string>;
    typ: z__default.ZodOptional<z__default.ZodString>;
    kid: z__default.ZodOptional<z__default.ZodString>;
    jwk: z__default.ZodOptional<z__default.ZodObject<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    x5c: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    trust_chain: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, {
    key_attestation: z__default.ZodOptional<z__default.ZodString>;
    typ: z__default.ZodLiteral<"openid4vci-proof+jwt">;
}>, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<z__default.objectUtil.extendShape<{
    alg: z__default.ZodEffects<z__default.ZodString, string, string>;
    typ: z__default.ZodOptional<z__default.ZodString>;
    kid: z__default.ZodOptional<z__default.ZodString>;
    jwk: z__default.ZodOptional<z__default.ZodObject<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    x5c: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    trust_chain: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, {
    key_attestation: z__default.ZodOptional<z__default.ZodString>;
    typ: z__default.ZodLiteral<"openid4vci-proof+jwt">;
}>, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<z__default.objectUtil.extendShape<{
    alg: z__default.ZodEffects<z__default.ZodString, string, string>;
    typ: z__default.ZodOptional<z__default.ZodString>;
    kid: z__default.ZodOptional<z__default.ZodString>;
    jwk: z__default.ZodOptional<z__default.ZodObject<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    x5c: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    trust_chain: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, {
    key_attestation: z__default.ZodOptional<z__default.ZodString>;
    typ: z__default.ZodLiteral<"openid4vci-proof+jwt">;
}>, z__default.ZodTypeAny, "passthrough">>, z__default.objectOutputType<z__default.objectUtil.extendShape<{
    alg: z__default.ZodEffects<z__default.ZodString, string, string>;
    typ: z__default.ZodOptional<z__default.ZodString>;
    kid: z__default.ZodOptional<z__default.ZodString>;
    jwk: z__default.ZodOptional<z__default.ZodObject<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    x5c: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    trust_chain: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, {
    key_attestation: z__default.ZodOptional<z__default.ZodString>;
    typ: z__default.ZodLiteral<"openid4vci-proof+jwt">;
}>, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<z__default.objectUtil.extendShape<{
    alg: z__default.ZodEffects<z__default.ZodString, string, string>;
    typ: z__default.ZodOptional<z__default.ZodString>;
    kid: z__default.ZodOptional<z__default.ZodString>;
    jwk: z__default.ZodOptional<z__default.ZodObject<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        kty: z__default.ZodString;
        crv: z__default.ZodOptional<z__default.ZodString>;
        x: z__default.ZodOptional<z__default.ZodString>;
        y: z__default.ZodOptional<z__default.ZodString>;
        e: z__default.ZodOptional<z__default.ZodString>;
        n: z__default.ZodOptional<z__default.ZodString>;
        alg: z__default.ZodOptional<z__default.ZodString>;
        d: z__default.ZodOptional<z__default.ZodString>;
        dp: z__default.ZodOptional<z__default.ZodString>;
        dq: z__default.ZodOptional<z__default.ZodString>;
        ext: z__default.ZodOptional<z__default.ZodBoolean>;
        k: z__default.ZodOptional<z__default.ZodString>;
        key_ops: z__default.ZodOptional<z__default.ZodString>;
        kid: z__default.ZodOptional<z__default.ZodString>;
        oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            d: z__default.ZodOptional<z__default.ZodString>;
            r: z__default.ZodOptional<z__default.ZodString>;
            t: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>, "many">>;
        p: z__default.ZodOptional<z__default.ZodString>;
        q: z__default.ZodOptional<z__default.ZodString>;
        qi: z__default.ZodOptional<z__default.ZodString>;
        use: z__default.ZodOptional<z__default.ZodString>;
        x5c: z__default.ZodOptional<z__default.ZodString>;
        x5t: z__default.ZodOptional<z__default.ZodString>;
        'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
        x5u: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    x5c: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
    trust_chain: z__default.ZodOptional<z__default.ZodArray<z__default.ZodString, "many">>;
}, {
    key_attestation: z__default.ZodOptional<z__default.ZodString>;
    typ: z__default.ZodLiteral<"openid4vci-proof+jwt">;
}>, z__default.ZodTypeAny, "passthrough">>;
type CredentialRequestJwtProofTypeHeader = z__default.infer<typeof zCredentialRequestJwtProofTypeHeader>;
declare const zCredentialRequestJwtProofTypePayload: z__default.ZodObject<{
    aud: z__default.ZodEffects<z__default.ZodString, string, string>;
    iat: z__default.ZodNumber;
    iss: z__default.ZodOptional<z__default.ZodString>;
    exp: z__default.ZodOptional<z__default.ZodNumber>;
    nbf: z__default.ZodOptional<z__default.ZodNumber>;
    nonce: z__default.ZodOptional<z__default.ZodString>;
    jti: z__default.ZodOptional<z__default.ZodString>;
    cnf: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodOptional<z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        jkt: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodOptional<z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        jkt: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodOptional<z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        jkt: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    status: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>>;
}, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
    aud: z__default.ZodEffects<z__default.ZodString, string, string>;
    iat: z__default.ZodNumber;
    iss: z__default.ZodOptional<z__default.ZodString>;
    exp: z__default.ZodOptional<z__default.ZodNumber>;
    nbf: z__default.ZodOptional<z__default.ZodNumber>;
    nonce: z__default.ZodOptional<z__default.ZodString>;
    jti: z__default.ZodOptional<z__default.ZodString>;
    cnf: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodOptional<z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        jkt: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodOptional<z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        jkt: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodOptional<z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        jkt: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    status: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>>;
}, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
    aud: z__default.ZodEffects<z__default.ZodString, string, string>;
    iat: z__default.ZodNumber;
    iss: z__default.ZodOptional<z__default.ZodString>;
    exp: z__default.ZodOptional<z__default.ZodNumber>;
    nbf: z__default.ZodOptional<z__default.ZodNumber>;
    nonce: z__default.ZodOptional<z__default.ZodString>;
    jti: z__default.ZodOptional<z__default.ZodString>;
    cnf: z__default.ZodOptional<z__default.ZodObject<{
        jwk: z__default.ZodOptional<z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        jkt: z__default.ZodOptional<z__default.ZodString>;
    }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
        jwk: z__default.ZodOptional<z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        jkt: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
        jwk: z__default.ZodOptional<z__default.ZodObject<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
            kty: z__default.ZodString;
            crv: z__default.ZodOptional<z__default.ZodString>;
            x: z__default.ZodOptional<z__default.ZodString>;
            y: z__default.ZodOptional<z__default.ZodString>;
            e: z__default.ZodOptional<z__default.ZodString>;
            n: z__default.ZodOptional<z__default.ZodString>;
            alg: z__default.ZodOptional<z__default.ZodString>;
            d: z__default.ZodOptional<z__default.ZodString>;
            dp: z__default.ZodOptional<z__default.ZodString>;
            dq: z__default.ZodOptional<z__default.ZodString>;
            ext: z__default.ZodOptional<z__default.ZodBoolean>;
            k: z__default.ZodOptional<z__default.ZodString>;
            key_ops: z__default.ZodOptional<z__default.ZodString>;
            kid: z__default.ZodOptional<z__default.ZodString>;
            oth: z__default.ZodOptional<z__default.ZodArray<z__default.ZodObject<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, "passthrough", z__default.ZodTypeAny, z__default.objectOutputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">, z__default.objectInputType<{
                d: z__default.ZodOptional<z__default.ZodString>;
                r: z__default.ZodOptional<z__default.ZodString>;
                t: z__default.ZodOptional<z__default.ZodString>;
            }, z__default.ZodTypeAny, "passthrough">>, "many">>;
            p: z__default.ZodOptional<z__default.ZodString>;
            q: z__default.ZodOptional<z__default.ZodString>;
            qi: z__default.ZodOptional<z__default.ZodString>;
            use: z__default.ZodOptional<z__default.ZodString>;
            x5c: z__default.ZodOptional<z__default.ZodString>;
            x5t: z__default.ZodOptional<z__default.ZodString>;
            'x5t#S256': z__default.ZodOptional<z__default.ZodString>;
            x5u: z__default.ZodOptional<z__default.ZodString>;
        }, z__default.ZodTypeAny, "passthrough">>>;
        jkt: z__default.ZodOptional<z__default.ZodString>;
    }, z__default.ZodTypeAny, "passthrough">>>;
    status: z__default.ZodOptional<z__default.ZodRecord<z__default.ZodString, z__default.ZodAny>>;
}, z__default.ZodTypeAny, "passthrough">>;
type CredentialRequestJwtProofTypePayload = z__default.infer<typeof zCredentialRequestJwtProofTypePayload>;

type KeyAttestationJwtUse = 'proof_type.jwt' | 'proof_type.attestation';

declare const zAttestationProofTypeIdentifier: z__default.ZodLiteral<"attestation">;
type AttestationProofTypeIdentifier = z__default.infer<typeof zAttestationProofTypeIdentifier>;

type ProofTypeIdentifier = JwtProofTypeIdentifier | AttestationProofTypeIdentifier;

declare const zMsoMdocFormatIdentifier: z__default.ZodLiteral<"mso_mdoc">;
type MsoMdocFormatIdentifier = z__default.infer<typeof zMsoMdocFormatIdentifier>;

declare const zSdJwtVcFormatIdentifier: z__default.ZodLiteral<"vc+sd-jwt">;
type SdJwtVcFormatIdentifier = z__default.infer<typeof zSdJwtVcFormatIdentifier>;

declare const zJwtVcJsonFormatIdentifier: z__default.ZodLiteral<"jwt_vc_json">;
type JwtVcJsonFormatIdentifier = z__default.infer<typeof zJwtVcJsonFormatIdentifier>;

declare const zJwtVcJsonLdFormatIdentifier: z__default.ZodLiteral<"jwt_vc_json-ld">;
type JwtVcJsonLdFormatIdentifier = z__default.infer<typeof zJwtVcJsonLdFormatIdentifier>;

declare const zLdpVcFormatIdentifier: z__default.ZodLiteral<"ldp_vc">;
type LdpVcFormatIdentifier = z__default.infer<typeof zLdpVcFormatIdentifier>;

type CredentialFormatIdentifier = MsoMdocFormatIdentifier | SdJwtVcFormatIdentifier | LdpVcFormatIdentifier | JwtVcJsonLdFormatIdentifier | JwtVcJsonFormatIdentifier;

interface ExtractScopesForCredentialConfigurationIdsOptions {
    /**
     * The credential configuration ids to extract the scope from
     */
    credentialConfigurationIds: string[];
    /**
     * Wheter to throw an error if the correspdong credential configuration
     * for a provided credential configuration id has no scope.
     *
     * @default false
     */
    throwOnConfigurationWithoutScope?: boolean;
    /**
     * The issuer metadata
     */
    issuerMetadata: IssuerMetadataResult;
}
declare function extractScopesForCredentialConfigurationIds(options: ExtractScopesForCredentialConfigurationIdsOptions): string[] | undefined;
/**
 * Transforms draft 11 credentials supported syntax to credential configurations supported
 *
 * @throws if a credentials supported entry without id is passed
 * @throws if a credentials supported entry with invalid structure or format specific properties is passed
 */
declare function credentialsSupportedToCredentialConfigurationsSupported(credentialsSupported: Array<z__default.input<typeof zCredentialConfigurationSupportedDraft11To14>>): CredentialConfigurationsSupported;

interface CreateCredentialRequestJwtProofOptions {
    /**
     * Nonce to use in the jwt. Should be derived from the c_nonce
     */
    nonce?: string;
    /**
     * The credential issuer identifier
     */
    credentialIssuer: string;
    /**
     * The date when the token was issued. If not provided the current time will be used.
     */
    issuedAt?: Date;
    /**
     * The client id of the wallet requesting the credential. Should not be included when using
     * the pre-authorized code flow
     */
    clientId?: string;
    /**
     * Key attestation jwt that the proof should based on. In this case it is required that the `signer` uses
     * a key from the `attested_keys` in the key attestation jwt payload.
     */
    keyAttestationJwt?: string;
    signer: JwtSigner;
    callbacks: Pick<CallbackContext, 'signJwt' | 'hash'>;
}
interface VerifyCredentialRequestJwtProofOptions {
    /**
     * The proof jwt
     */
    jwt: string;
    /**
     * Expected nonce. Should be a c_nonce previously shared with the wallet
     */
    expectedNonce?: string;
    /**
     * Date at which the nonce will expire
     */
    nonceExpiresAt?: Date;
    /**
     * The credential issuer identifier, will be matched against the `aud` claim.
     */
    credentialIssuer: string;
    /**
     * The client id of the wallet requesting the credential, if available.
     */
    clientId?: string;
    /**
     * Current time, if not provided a new date instance will be created
     */
    now?: Date;
    /**
     * Callbacks required for the jwt verification.
     *
     * Will be used for the jwt proof, and optionally a `key_attestation` in the jwt proof header.
     */
    callbacks: Pick<CallbackContext, 'verifyJwt' | 'hash'>;
}

interface RequestNonceOptions {
    issuerMetadata: IssuerMetadataResult;
    /**
     * Custom fetch implementation to use
     */
    fetch?: Fetch;
}
interface CreateNonceResponseOptions {
    cNonce: string;
    cNonceExpiresIn?: number;
    /**
     * Additional payload to include in the nonce response.
     *
     * Will be applied after default params to allow extension so be cautious
     */
    additionalPayload?: Record<string, unknown>;
}

declare enum AuthorizationFlow {
    Oauth2Redirect = "Oauth2Redirect",
    PresentationDuringIssuance = "PresentationDuringIssuance"
}
interface Oid4vciClientOptions {
    /**
     * Callbacks required for the oid4vc client
     */
    callbacks: Omit<CallbackContext, 'verifyJwt' | 'clientAuthentication'>;
}
declare class Oid4vciClient {
    private options;
    private oauth2Client;
    constructor(options: Oid4vciClientOptions);
    getKnownCredentialConfigurationsSupported(credentialIssuerMetadata: CredentialIssuerMetadata): CredentialConfigurationsSupportedWithFormats;
    /**
     * Resolve a credential offer into a credential offer object, handling both
     * 'credential_offer' and 'credential_offer_uri' params.
     */
    resolveCredentialOffer(credentialOffer: string): Promise<CredentialOfferObject>;
    resolveIssuerMetadata(credentialIssuer: string): Promise<IssuerMetadataResult>;
    /**
     * Retrieve an authorization code for a presentation during issuance session
     *
     * This can only be called if an authorization challenge was performed before and returned a
     * `presentation` paramater along with an `auth_session`. If the presentation response included
     * an `presentation_during_issuance_session` parameter it MUST be included in this request as well.
     */
    retrieveAuthorizationCodeUsingPresentation(options: {
        /**
         * Auth session as returned by `{@link Oid4vciClient.initiateAuthorization}
         */
        authSession: string;
        /**
         * Presentation during issuance session, obtained from the RP after submitting
         * openid4vp authorization response
         */
        presentationDuringIssuanceSession?: string;
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
        dpop?: RequestDpopOptions;
    }): Promise<{
        authorizationChallengeResponse: z.objectOutputType<{
            authorization_code: z.ZodString;
        }, z.ZodTypeAny, "passthrough">;
        dpop: {
            nonce: any;
            signer: _openid4vc_oauth2.JwtSignerJwk;
        } | undefined;
    }>;
    /**
     * Initiates authorization for credential issuance. It handles the following cases:
     * - Authorization Challenge
     * - Pushed Authorization Request
     * - Regular Authorization url
     *
     * In case the authorization challenge request returns an error with `insufficient_authorization`
     * with a `presentation` field it means the authorization server expects presentation of credentials
     * before issuance of crednetials. If this is the case, the value in `presentation` should be treated
     * as an openid4vp authorization request and submitted to the verifier. Once the presentation response
     * has been submitted, the RP will respnosd with a `presentation_during_issuance_session` parameter.
     * Together with the `auth_session` parameter returned in this call you can retrieve an `authorization_code`
     * using
     */
    initiateAuthorization(options: Omit<CreateAuthorizationRequestUrlOptions, 'callbacks' | 'authorizationServerMetadata'> & {
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        authorizationFlow: AuthorizationFlow.PresentationDuringIssuance;
        oid4vpRequestUrl: string;
        authSession: string;
        authorizationServer: string;
    } | {
        authorizationFlow: AuthorizationFlow.Oauth2Redirect;
        authorizationRequestUrl: string;
        authorizationServer: string;
        pkce?: CreatePkceReturn;
    }>;
    /**
     * Convenience method around {@link Oauth2Client.createAuthorizationRequestUrl}
     * but specifically focused on a credential offer
     */
    createAuthorizationRequestUrlFromOffer(options: Omit<CreateAuthorizationRequestUrlOptions, 'callbacks' | 'authorizationServerMetadata'> & {
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        authorizationRequestUrl: string;
        pkce: CreatePkceReturn | undefined;
        dpop: RequestDpopOptions | undefined;
        authorizationServer: string;
    }>;
    /**
     * Convenience method around {@link Oauth2Client.retrievePreAuthorizedCodeAccessToken}
     * but specifically focused on a credential offer
     */
    retrievePreAuthorizedCodeAccessTokenFromOffer({ credentialOffer, issuerMetadata, additionalRequestPayload, txCode, dpop, clientAttestation, }: Omit<RetrievePreAuthorizedCodeAccessTokenOptions, 'callbacks' | 'authorizationServerMetadata' | 'preAuthorizedCode' | 'resource'> & {
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        authorizationServer: string;
        accessTokenResponse: _openid4vc_oauth2.AccessTokenResponse;
        dpop?: RequestDpopOptions;
    }>;
    /**
     * Convenience method around {@link Oauth2Client.retrieveAuthorizationCodeAccessTokenFrom}
     * but specifically focused on a credential offer
     */
    retrieveAuthorizationCodeAccessTokenFromOffer({ issuerMetadata, additionalRequestPayload, credentialOffer, authorizationCode, pkceCodeVerifier, redirectUri, dpop, clientAttestation, }: Omit<RetrieveAuthorizationCodeAccessTokenOptions, 'authorizationServerMetadata' | 'callbacks'> & {
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        authorizationServer: string;
        accessTokenResponse: _openid4vc_oauth2.AccessTokenResponse;
        dpop?: RequestDpopOptions;
    }>;
    /**
     * Request a nonce to be used in credential request proofs from the `nonce_endpoint`
     *
     * @throws Oid4vciError - if no `nonce_endpoint` is configured in the issuer metadata
     * @thrwos InvalidFetchResponseError - if the nonce endpoint did not return a succesfull response
     * @throws ValidationError - if validating the nonce response failed
     */
    requestNonce(options: Pick<RequestNonceOptions, 'issuerMetadata'>): Promise<z.objectOutputType<{
        c_nonce: z.ZodString;
        c_nonce_expires_in: z.ZodOptional<z.ZodNumber>;
    }, z.ZodTypeAny, "passthrough">>;
    /**
     * Creates the jwt proof payload and header to be included in a credential request.
     */
    createCredentialRequestJwtProof(options: Pick<CreateCredentialRequestJwtProofOptions, 'signer' | 'nonce' | 'issuedAt' | 'clientId' | 'keyAttestationJwt'> & {
        issuerMetadata: IssuerMetadataResult;
        credentialConfigurationId: string;
    }): Promise<{
        jwt: string;
    }>;
    /**
     * @throws Oid4vciRetrieveCredentialsError - if an unsuccesfull response or the respnose couldn't be parsed as credential response
     * @throws ValidationError - if validation of the credential request failed
     * @throws Oid4vciError - if the `credentialConfigurationId` couldn't be found, or if the the format specific request couldn't be constructed
     */
    retrieveCredentials({ issuerMetadata, proof, proofs, credentialConfigurationId, additionalRequestPayload, accessToken, dpop, }: Pick<RetrieveCredentialsWithFormatOptions, 'accessToken' | 'additionalRequestPayload' | 'issuerMetadata' | 'proof' | 'proofs' | 'dpop'> & {
        credentialConfigurationId: string;
    }): Promise<RetrieveCredentialsResponseOk>;
    /**
     * @throws Oid4vciSendNotificationError - if an unsuccesfull response
     * @throws ValidationError - if validation of the notification request failed
     */
    sendNotification({ issuerMetadata, notification, additionalRequestPayload, accessToken, dpop, }: Pick<SendNotifcationOptions, 'accessToken' | 'additionalRequestPayload' | 'issuerMetadata' | 'dpop' | 'notification'>): Promise<_openid4vc_oauth2.ResourceRequestResponseOk>;
}

interface CreateCredentialOfferGrantsOptions {
    [preAuthorizedCodeGrantIdentifier]?: Partial<CredentialOfferPreAuthorizedCodeGrant>;
    [authorizationCodeGrantIdentifier]?: CredenialOfferAuthorizationCodeGrant;
    [key: string]: unknown;
}
interface CreateCredentialOfferOptions {
    issuerMetadata: IssuerMetadataResult;
    /**
     * The credential configuration ids to be offered
     */
    credentialConfigurationIds: string[];
    /**
     * Grants to include in the credential offer
     */
    grants: CreateCredentialOfferGrantsOptions;
    /**
     * Additional payload to include in the body of the credential offer. Will be applied
     * after the other fields, allowing to override common properties, so be cautious.
     */
    additionalPayload?: Record<string, unknown>;
    /**
     * If provided the encoded credential offer will use the `credential_offer_uri` parameter
     * instaed of directly adding the `credential_offer`. Requires hosting of the `credential_offer_uri`
     */
    credentialOfferUri?: string;
    /**
     * The scheme to use for the credential offer.
     *
     * @default `openid-credential-offer://`
     */
    credentialOfferScheme?: string;
    /**
     * Callbacks used to create credential offer
     */
    callbacks: Pick<CallbackContext, 'generateRandom'>;
}

interface CreateCredentialResponseOptions {
    credentialRequest: ParseCredentialRequestReturn;
    credential?: CredentialResponse['credential'];
    credentials?: CredentialResponse['credentials'];
    cNonce?: string;
    cNonceExpiresInSeconds?: number;
    notificationId?: string;
    /**
     * Additional payload to include in the credential response
     */
    additionalPayload?: Record<string, unknown>;
}

interface VerifyKeyAttestationJwtOptions {
    /**
     * The compact key attestation jwt
     */
    keyAttestationJwt: string;
    /**
     * Expected nonce. If the key attestation is used directly as proof this should be provided.
     */
    expectedNonce?: string;
    /**
     * Date at which the nonce will expire
     */
    nonceExpiresAt?: Date;
    /**
     * The intended use of the key attestation. Based on this additional validation
     * is performed.
     *
     * - `proof_type.jwt` -> `exp` MUST be set
     * - `proof_type.attestation` -> `nonce` MUST be set
     */
    use?: KeyAttestationJwtUse;
    /**
     * Current time, if not provided a new date instance will be created
     */
    now?: Date;
    /**
     * Callbacks required for the key attestation jwt verification
     */
    callbacks: Pick<CallbackContext, 'verifyJwt'>;
}

interface VerifyCredentialRequestAttestationProofOptions extends Omit<VerifyKeyAttestationJwtOptions, 'use'> {
}

interface Oid4vciIssuerOptions {
    /**
     * Callbacks required for the oid4vc issuer
     */
    callbacks: CallbackContext;
}
declare class Oid4vciIssuer {
    private options;
    constructor(options: Oid4vciIssuerOptions);
    getCredentialIssuerMetadataDraft11(credentialIssuerMetadata: CredentialIssuerMetadata): z.objectOutputType<z.objectUtil.extendShape<{
        credential_issuer: z.ZodEffects<z.ZodString, string, string>;
        authorization_servers: z.ZodOptional<z.ZodArray<z.ZodEffects<z.ZodString, string, string>, "many">>;
        credential_endpoint: z.ZodEffects<z.ZodString, string, string>;
        deferred_credential_endpoint: z.ZodOptional<z.ZodEffects<z.ZodString, string, string>>;
        notification_endpoint: z.ZodOptional<z.ZodEffects<z.ZodString, string, string>>;
        nonce_endpoint: z.ZodOptional<z.ZodEffects<z.ZodString, string, string>>;
        credential_response_encryption: z.ZodOptional<z.ZodObject<{
            alg_values_supported: z.ZodArray<z.ZodString, "many">;
            enc_values_supported: z.ZodArray<z.ZodString, "many">;
            encryption_required: z.ZodBoolean;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            alg_values_supported: z.ZodArray<z.ZodString, "many">;
            enc_values_supported: z.ZodArray<z.ZodString, "many">;
            encryption_required: z.ZodBoolean;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            alg_values_supported: z.ZodArray<z.ZodString, "many">;
            enc_values_supported: z.ZodArray<z.ZodString, "many">;
            encryption_required: z.ZodBoolean;
        }, z.ZodTypeAny, "passthrough">>>;
        batch_credential_issuance: z.ZodOptional<z.ZodObject<{
            batch_size: z.ZodNumber;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            batch_size: z.ZodNumber;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            batch_size: z.ZodNumber;
        }, z.ZodTypeAny, "passthrough">>>;
        signed_metadata: z.ZodOptional<z.ZodString>;
        display: z.ZodOptional<z.ZodArray<z.ZodObject<{
            name: z.ZodOptional<z.ZodString>;
            locale: z.ZodOptional<z.ZodString>;
            logo: z.ZodOptional<z.ZodObject<{
                uri: z.ZodOptional<z.ZodString>;
                alt_text: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                uri: z.ZodOptional<z.ZodString>;
                alt_text: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                uri: z.ZodOptional<z.ZodString>;
                alt_text: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            name: z.ZodOptional<z.ZodString>;
            locale: z.ZodOptional<z.ZodString>;
            logo: z.ZodOptional<z.ZodObject<{
                uri: z.ZodOptional<z.ZodString>;
                alt_text: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                uri: z.ZodOptional<z.ZodString>;
                alt_text: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                uri: z.ZodOptional<z.ZodString>;
                alt_text: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            name: z.ZodOptional<z.ZodString>;
            locale: z.ZodOptional<z.ZodString>;
            logo: z.ZodOptional<z.ZodObject<{
                uri: z.ZodOptional<z.ZodString>;
                alt_text: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                uri: z.ZodOptional<z.ZodString>;
                alt_text: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                uri: z.ZodOptional<z.ZodString>;
                alt_text: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>>;
        }, z.ZodTypeAny, "passthrough">>, "many">>;
        credential_configurations_supported: z.ZodRecord<z.ZodString, z.ZodEffects<z.ZodObject<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, z.ZodTypeAny, "passthrough">>, z.objectOutputType<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, z.ZodTypeAny, "passthrough">>>;
    }, {
        credentials_supported: z.ZodArray<z.ZodPipeline<z.ZodEffects<z.ZodIntersection<z.ZodEffects<z.ZodObject<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, z.ZodTypeAny, "passthrough">>, z.objectOutputType<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            format: z.ZodString;
            scope: z.ZodOptional<z.ZodString>;
            cryptographic_binding_methods_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            credential_signing_alg_values_supported: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            proof_types_supported: z.ZodOptional<z.ZodRecord<z.ZodUnion<[z.ZodLiteral<"jwt">, z.ZodLiteral<"attestation">, z.ZodString]>, z.ZodObject<{
                proof_signing_alg_values_supported: z.ZodArray<z.ZodString, "many">;
                key_attestations_required: z.ZodOptional<z.ZodObject<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough">>>;
            }, "strip", z.ZodTypeAny, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectOutputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }>>>;
            display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">>;
        }, z.ZodTypeAny, "passthrough">>, z.ZodObject<{
            id: z.ZodString;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            id: z.ZodString;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            id: z.ZodString;
        }, z.ZodTypeAny, "passthrough">>>, {
            id: string;
            display?: {
                logo?: {
                    alt_text?: string | undefined;
                    url: string;
                } | undefined;
                name: string;
                description?: string | undefined;
                locale?: string | undefined;
                background_color?: string | undefined;
                text_color?: string | undefined;
            }[] | undefined;
            cryptographic_suites_supported?: string[] | undefined;
            format: string;
            cryptographic_binding_methods_supported?: string[] | undefined;
        }, {
            format: string;
            scope?: string | undefined;
            display?: z.objectInputType<{
                name: z.ZodString;
                locale: z.ZodOptional<z.ZodString>;
                logo: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                    alt_text: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                description: z.ZodOptional<z.ZodString>;
                background_color: z.ZodOptional<z.ZodString>;
                background_image: z.ZodOptional<z.ZodObject<{
                    uri: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    uri: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                text_color: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">[] | undefined;
            cryptographic_binding_methods_supported?: string[] | undefined;
            credential_signing_alg_values_supported?: string[] | undefined;
            proof_types_supported?: Record<string, {
                proof_signing_alg_values_supported: string[];
                key_attestations_required?: z.objectInputType<{
                    key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                    user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                }, z.ZodTypeAny, "passthrough"> | undefined;
            }> | undefined;
        } & {
            [k: string]: unknown;
        } & {
            id: string;
        }>, z.ZodUnion<[z.ZodIntersection<z.ZodEffects<z.ZodObject<{
            format: z.ZodLiteral<"ldp_vc">;
            credential_definition: z.ZodObject<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            format: z.ZodLiteral<"ldp_vc">;
            credential_definition: z.ZodObject<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            format: z.ZodLiteral<"ldp_vc">;
            credential_definition: z.ZodObject<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">>, {
            types: string[];
            '@context': string[];
            credentialSubject?: Record<string, any[] | Record<string, any> | z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">> | undefined;
            format: "ldp_vc";
            order?: string[] | undefined;
        }, z.objectInputType<{
            format: z.ZodLiteral<"ldp_vc">;
            credential_definition: z.ZodObject<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">>, z.ZodObject<{
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            format: z.ZodLiteral<"ldp_vc">;
            '@context': z.ZodArray<z.ZodString, "many">;
            types: z.ZodArray<z.ZodString, "many">;
            credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">>]>>>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            format: z.ZodLiteral<"ldp_vc">;
            '@context': z.ZodArray<z.ZodString, "many">;
            types: z.ZodArray<z.ZodString, "many">;
            credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">>]>>>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            format: z.ZodLiteral<"ldp_vc">;
            '@context': z.ZodArray<z.ZodString, "many">;
            types: z.ZodArray<z.ZodString, "many">;
            credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">>]>>>;
        }, z.ZodTypeAny, "passthrough">>>, z.ZodIntersection<z.ZodEffects<z.ZodObject<{
            format: z.ZodLiteral<"jwt_vc_json">;
            credential_definition: z.ZodObject<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            format: z.ZodLiteral<"jwt_vc_json">;
            credential_definition: z.ZodObject<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            format: z.ZodLiteral<"jwt_vc_json">;
            credential_definition: z.ZodObject<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">>, {
            credentialSubject?: Record<string, any[] | Record<string, any> | z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">> | undefined;
            types: string[];
            format: "jwt_vc_json";
            order?: string[] | undefined;
        }, z.objectInputType<{
            format: z.ZodLiteral<"jwt_vc_json">;
            credential_definition: z.ZodObject<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">>, z.ZodObject<{
            format: z.ZodLiteral<"jwt_vc_json">;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            types: z.ZodArray<z.ZodString, "many">;
            credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">>]>>>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            format: z.ZodLiteral<"jwt_vc_json">;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            types: z.ZodArray<z.ZodString, "many">;
            credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">>]>>>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            format: z.ZodLiteral<"jwt_vc_json">;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            types: z.ZodArray<z.ZodString, "many">;
            credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">>]>>>;
        }, z.ZodTypeAny, "passthrough">>>, z.ZodIntersection<z.ZodEffects<z.ZodObject<{
            format: z.ZodLiteral<"jwt_vc_json-ld">;
            credential_definition: z.ZodObject<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            format: z.ZodLiteral<"jwt_vc_json-ld">;
            credential_definition: z.ZodObject<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            format: z.ZodLiteral<"jwt_vc_json-ld">;
            credential_definition: z.ZodObject<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">>, {
            types: string[];
            '@context': string[];
            credentialSubject?: Record<string, any[] | Record<string, any> | z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">> | undefined;
            format: "jwt_vc_json-ld";
            order?: string[] | undefined;
        }, z.objectInputType<{
            format: z.ZodLiteral<"jwt_vc_json-ld">;
            credential_definition: z.ZodObject<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                '@context': z.ZodArray<z.ZodString, "many">;
                type: z.ZodArray<z.ZodString, "many">;
                credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    mandatory: z.ZodOptional<z.ZodBoolean>;
                    value_type: z.ZodOptional<z.ZodString>;
                    display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        name: z.ZodOptional<z.ZodString>;
                        locale: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                }, z.ZodTypeAny, "passthrough">>]>>>;
            }, z.ZodTypeAny, "passthrough">>;
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">>, z.ZodObject<{
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            format: z.ZodLiteral<"jwt_vc_json-ld">;
            '@context': z.ZodArray<z.ZodString, "many">;
            types: z.ZodArray<z.ZodString, "many">;
            credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">>]>>>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            format: z.ZodLiteral<"jwt_vc_json-ld">;
            '@context': z.ZodArray<z.ZodString, "many">;
            types: z.ZodArray<z.ZodString, "many">;
            credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">>]>>>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            order: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            format: z.ZodLiteral<"jwt_vc_json-ld">;
            '@context': z.ZodArray<z.ZodString, "many">;
            types: z.ZodArray<z.ZodString, "many">;
            credentialSubject: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodUnion<[z.ZodArray<z.ZodAny, "many">, z.ZodRecord<z.ZodString, z.ZodAny>, z.ZodObject<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                mandatory: z.ZodOptional<z.ZodBoolean>;
                value_type: z.ZodOptional<z.ZodString>;
                display: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    name: z.ZodOptional<z.ZodString>;
                    locale: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
            }, z.ZodTypeAny, "passthrough">>]>>>;
        }, z.ZodTypeAny, "passthrough">>>, z.ZodObject<{
            format: z.ZodEffects<z.ZodString, string, string>;
        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
            format: z.ZodEffects<z.ZodString, string, string>;
        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
            format: z.ZodEffects<z.ZodString, string, string>;
        }, z.ZodTypeAny, "passthrough">>]>>, "many">;
    }>, z.ZodTypeAny, "passthrough">;
    getKnownCredentialConfigurationsSupported(credentialIssuerMetadata: CredentialIssuerMetadata): CredentialConfigurationsSupportedWithFormats;
    /**
     * Create issuer metadata and validates the structure is correct
     */
    createCredentialIssuerMetadata(credentialIssuerMetadata: CredentialIssuerMetadata): CredentialIssuerMetadata;
    createCredentialOffer(options: Pick<CreateCredentialOfferOptions, 'issuerMetadata' | 'additionalPayload' | 'grants' | 'credentialOfferUri' | 'credentialOfferScheme' | 'credentialConfigurationIds'>): Promise<{
        credentialOffer: string;
        credentialOfferObject: CredentialOfferObject;
    }>;
    /**
     * @throws Oauth2ServerErrorResponseError - if verification of the jwt failed. You can extract
     *  the credential error response from this.
     */
    verifyCredentialRequestJwtProof(options: Pick<VerifyCredentialRequestJwtProofOptions, 'clientId' | 'jwt' | 'now' | 'expectedNonce' | 'nonceExpiresAt'> & {
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        header: z.objectOutputType<z.objectUtil.extendShape<{
            alg: z.ZodEffects<z.ZodString, string, string>;
            typ: z.ZodOptional<z.ZodString>;
            kid: z.ZodOptional<z.ZodString>;
            jwk: z.ZodOptional<z.ZodObject<{
                kty: z.ZodString;
                crv: z.ZodOptional<z.ZodString>;
                x: z.ZodOptional<z.ZodString>;
                y: z.ZodOptional<z.ZodString>;
                e: z.ZodOptional<z.ZodString>;
                n: z.ZodOptional<z.ZodString>;
                alg: z.ZodOptional<z.ZodString>;
                d: z.ZodOptional<z.ZodString>;
                dp: z.ZodOptional<z.ZodString>;
                dq: z.ZodOptional<z.ZodString>;
                ext: z.ZodOptional<z.ZodBoolean>;
                k: z.ZodOptional<z.ZodString>;
                key_ops: z.ZodOptional<z.ZodString>;
                kid: z.ZodOptional<z.ZodString>;
                oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
                p: z.ZodOptional<z.ZodString>;
                q: z.ZodOptional<z.ZodString>;
                qi: z.ZodOptional<z.ZodString>;
                use: z.ZodOptional<z.ZodString>;
                x5c: z.ZodOptional<z.ZodString>;
                x5t: z.ZodOptional<z.ZodString>;
                'x5t#S256': z.ZodOptional<z.ZodString>;
                x5u: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                kty: z.ZodString;
                crv: z.ZodOptional<z.ZodString>;
                x: z.ZodOptional<z.ZodString>;
                y: z.ZodOptional<z.ZodString>;
                e: z.ZodOptional<z.ZodString>;
                n: z.ZodOptional<z.ZodString>;
                alg: z.ZodOptional<z.ZodString>;
                d: z.ZodOptional<z.ZodString>;
                dp: z.ZodOptional<z.ZodString>;
                dq: z.ZodOptional<z.ZodString>;
                ext: z.ZodOptional<z.ZodBoolean>;
                k: z.ZodOptional<z.ZodString>;
                key_ops: z.ZodOptional<z.ZodString>;
                kid: z.ZodOptional<z.ZodString>;
                oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
                p: z.ZodOptional<z.ZodString>;
                q: z.ZodOptional<z.ZodString>;
                qi: z.ZodOptional<z.ZodString>;
                use: z.ZodOptional<z.ZodString>;
                x5c: z.ZodOptional<z.ZodString>;
                x5t: z.ZodOptional<z.ZodString>;
                'x5t#S256': z.ZodOptional<z.ZodString>;
                x5u: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                kty: z.ZodString;
                crv: z.ZodOptional<z.ZodString>;
                x: z.ZodOptional<z.ZodString>;
                y: z.ZodOptional<z.ZodString>;
                e: z.ZodOptional<z.ZodString>;
                n: z.ZodOptional<z.ZodString>;
                alg: z.ZodOptional<z.ZodString>;
                d: z.ZodOptional<z.ZodString>;
                dp: z.ZodOptional<z.ZodString>;
                dq: z.ZodOptional<z.ZodString>;
                ext: z.ZodOptional<z.ZodBoolean>;
                k: z.ZodOptional<z.ZodString>;
                key_ops: z.ZodOptional<z.ZodString>;
                kid: z.ZodOptional<z.ZodString>;
                oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
                p: z.ZodOptional<z.ZodString>;
                q: z.ZodOptional<z.ZodString>;
                qi: z.ZodOptional<z.ZodString>;
                use: z.ZodOptional<z.ZodString>;
                x5c: z.ZodOptional<z.ZodString>;
                x5t: z.ZodOptional<z.ZodString>;
                'x5t#S256': z.ZodOptional<z.ZodString>;
                x5u: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>>;
            x5c: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            trust_chain: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, {
            key_attestation: z.ZodOptional<z.ZodString>;
            typ: z.ZodLiteral<"openid4vci-proof+jwt">;
        }>, z.ZodTypeAny, "passthrough">;
        payload: z.objectOutputType<{
            aud: z.ZodEffects<z.ZodString, string, string>;
            iat: z.ZodNumber;
            iss: z.ZodOptional<z.ZodString>;
            exp: z.ZodOptional<z.ZodNumber>;
            nbf: z.ZodOptional<z.ZodNumber>;
            nonce: z.ZodOptional<z.ZodString>;
            jti: z.ZodOptional<z.ZodString>;
            cnf: z.ZodOptional<z.ZodObject<{
                jwk: z.ZodOptional<z.ZodObject<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                jkt: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                jwk: z.ZodOptional<z.ZodObject<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                jkt: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                jwk: z.ZodOptional<z.ZodObject<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                jkt: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>>;
            status: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodAny>>;
        }, z.ZodTypeAny, "passthrough">;
        signer: _openid4vc_oauth2.JwtSignerWithJwk;
        keyAttestation: {
            header: z.objectOutputType<{
                typ: z.ZodLiteral<"keyattestation+jwt">;
                alg: z.ZodEffects<z.ZodString, string, string>;
                kid: z.ZodOptional<z.ZodString>;
                jwk: z.ZodOptional<z.ZodObject<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                x5c: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
                trust_chain: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            }, z.ZodTypeAny, "passthrough">;
            payload: z.objectOutputType<{
                nonce: z.ZodString | z.ZodOptional<z.ZodString>;
                exp: z.ZodNumber | z.ZodOptional<z.ZodNumber>;
                iat: z.ZodNumber;
                attested_keys: z.ZodArray<z.ZodObject<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">;
                key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
                certification: z.ZodOptional<z.ZodString>;
                iss: z.ZodOptional<z.ZodString>;
                aud: z.ZodOptional<z.ZodString>;
                nbf: z.ZodOptional<z.ZodNumber>;
                jti: z.ZodOptional<z.ZodString>;
                cnf: z.ZodOptional<z.ZodObject<{
                    jwk: z.ZodOptional<z.ZodObject<{
                        kty: z.ZodString;
                        crv: z.ZodOptional<z.ZodString>;
                        x: z.ZodOptional<z.ZodString>;
                        y: z.ZodOptional<z.ZodString>;
                        e: z.ZodOptional<z.ZodString>;
                        n: z.ZodOptional<z.ZodString>;
                        alg: z.ZodOptional<z.ZodString>;
                        d: z.ZodOptional<z.ZodString>;
                        dp: z.ZodOptional<z.ZodString>;
                        dq: z.ZodOptional<z.ZodString>;
                        ext: z.ZodOptional<z.ZodBoolean>;
                        k: z.ZodOptional<z.ZodString>;
                        key_ops: z.ZodOptional<z.ZodString>;
                        kid: z.ZodOptional<z.ZodString>;
                        oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">>, "many">>;
                        p: z.ZodOptional<z.ZodString>;
                        q: z.ZodOptional<z.ZodString>;
                        qi: z.ZodOptional<z.ZodString>;
                        use: z.ZodOptional<z.ZodString>;
                        x5c: z.ZodOptional<z.ZodString>;
                        x5t: z.ZodOptional<z.ZodString>;
                        'x5t#S256': z.ZodOptional<z.ZodString>;
                        x5u: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        kty: z.ZodString;
                        crv: z.ZodOptional<z.ZodString>;
                        x: z.ZodOptional<z.ZodString>;
                        y: z.ZodOptional<z.ZodString>;
                        e: z.ZodOptional<z.ZodString>;
                        n: z.ZodOptional<z.ZodString>;
                        alg: z.ZodOptional<z.ZodString>;
                        d: z.ZodOptional<z.ZodString>;
                        dp: z.ZodOptional<z.ZodString>;
                        dq: z.ZodOptional<z.ZodString>;
                        ext: z.ZodOptional<z.ZodBoolean>;
                        k: z.ZodOptional<z.ZodString>;
                        key_ops: z.ZodOptional<z.ZodString>;
                        kid: z.ZodOptional<z.ZodString>;
                        oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">>, "many">>;
                        p: z.ZodOptional<z.ZodString>;
                        q: z.ZodOptional<z.ZodString>;
                        qi: z.ZodOptional<z.ZodString>;
                        use: z.ZodOptional<z.ZodString>;
                        x5c: z.ZodOptional<z.ZodString>;
                        x5t: z.ZodOptional<z.ZodString>;
                        'x5t#S256': z.ZodOptional<z.ZodString>;
                        x5u: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        kty: z.ZodString;
                        crv: z.ZodOptional<z.ZodString>;
                        x: z.ZodOptional<z.ZodString>;
                        y: z.ZodOptional<z.ZodString>;
                        e: z.ZodOptional<z.ZodString>;
                        n: z.ZodOptional<z.ZodString>;
                        alg: z.ZodOptional<z.ZodString>;
                        d: z.ZodOptional<z.ZodString>;
                        dp: z.ZodOptional<z.ZodString>;
                        dq: z.ZodOptional<z.ZodString>;
                        ext: z.ZodOptional<z.ZodBoolean>;
                        k: z.ZodOptional<z.ZodString>;
                        key_ops: z.ZodOptional<z.ZodString>;
                        kid: z.ZodOptional<z.ZodString>;
                        oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">>, "many">>;
                        p: z.ZodOptional<z.ZodString>;
                        q: z.ZodOptional<z.ZodString>;
                        qi: z.ZodOptional<z.ZodString>;
                        use: z.ZodOptional<z.ZodString>;
                        x5c: z.ZodOptional<z.ZodString>;
                        x5t: z.ZodOptional<z.ZodString>;
                        'x5t#S256': z.ZodOptional<z.ZodString>;
                        x5u: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>>;
                    jkt: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    jwk: z.ZodOptional<z.ZodObject<{
                        kty: z.ZodString;
                        crv: z.ZodOptional<z.ZodString>;
                        x: z.ZodOptional<z.ZodString>;
                        y: z.ZodOptional<z.ZodString>;
                        e: z.ZodOptional<z.ZodString>;
                        n: z.ZodOptional<z.ZodString>;
                        alg: z.ZodOptional<z.ZodString>;
                        d: z.ZodOptional<z.ZodString>;
                        dp: z.ZodOptional<z.ZodString>;
                        dq: z.ZodOptional<z.ZodString>;
                        ext: z.ZodOptional<z.ZodBoolean>;
                        k: z.ZodOptional<z.ZodString>;
                        key_ops: z.ZodOptional<z.ZodString>;
                        kid: z.ZodOptional<z.ZodString>;
                        oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">>, "many">>;
                        p: z.ZodOptional<z.ZodString>;
                        q: z.ZodOptional<z.ZodString>;
                        qi: z.ZodOptional<z.ZodString>;
                        use: z.ZodOptional<z.ZodString>;
                        x5c: z.ZodOptional<z.ZodString>;
                        x5t: z.ZodOptional<z.ZodString>;
                        'x5t#S256': z.ZodOptional<z.ZodString>;
                        x5u: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        kty: z.ZodString;
                        crv: z.ZodOptional<z.ZodString>;
                        x: z.ZodOptional<z.ZodString>;
                        y: z.ZodOptional<z.ZodString>;
                        e: z.ZodOptional<z.ZodString>;
                        n: z.ZodOptional<z.ZodString>;
                        alg: z.ZodOptional<z.ZodString>;
                        d: z.ZodOptional<z.ZodString>;
                        dp: z.ZodOptional<z.ZodString>;
                        dq: z.ZodOptional<z.ZodString>;
                        ext: z.ZodOptional<z.ZodBoolean>;
                        k: z.ZodOptional<z.ZodString>;
                        key_ops: z.ZodOptional<z.ZodString>;
                        kid: z.ZodOptional<z.ZodString>;
                        oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">>, "many">>;
                        p: z.ZodOptional<z.ZodString>;
                        q: z.ZodOptional<z.ZodString>;
                        qi: z.ZodOptional<z.ZodString>;
                        use: z.ZodOptional<z.ZodString>;
                        x5c: z.ZodOptional<z.ZodString>;
                        x5t: z.ZodOptional<z.ZodString>;
                        'x5t#S256': z.ZodOptional<z.ZodString>;
                        x5u: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        kty: z.ZodString;
                        crv: z.ZodOptional<z.ZodString>;
                        x: z.ZodOptional<z.ZodString>;
                        y: z.ZodOptional<z.ZodString>;
                        e: z.ZodOptional<z.ZodString>;
                        n: z.ZodOptional<z.ZodString>;
                        alg: z.ZodOptional<z.ZodString>;
                        d: z.ZodOptional<z.ZodString>;
                        dp: z.ZodOptional<z.ZodString>;
                        dq: z.ZodOptional<z.ZodString>;
                        ext: z.ZodOptional<z.ZodBoolean>;
                        k: z.ZodOptional<z.ZodString>;
                        key_ops: z.ZodOptional<z.ZodString>;
                        kid: z.ZodOptional<z.ZodString>;
                        oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">>, "many">>;
                        p: z.ZodOptional<z.ZodString>;
                        q: z.ZodOptional<z.ZodString>;
                        qi: z.ZodOptional<z.ZodString>;
                        use: z.ZodOptional<z.ZodString>;
                        x5c: z.ZodOptional<z.ZodString>;
                        x5t: z.ZodOptional<z.ZodString>;
                        'x5t#S256': z.ZodOptional<z.ZodString>;
                        x5u: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>>;
                    jkt: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    jwk: z.ZodOptional<z.ZodObject<{
                        kty: z.ZodString;
                        crv: z.ZodOptional<z.ZodString>;
                        x: z.ZodOptional<z.ZodString>;
                        y: z.ZodOptional<z.ZodString>;
                        e: z.ZodOptional<z.ZodString>;
                        n: z.ZodOptional<z.ZodString>;
                        alg: z.ZodOptional<z.ZodString>;
                        d: z.ZodOptional<z.ZodString>;
                        dp: z.ZodOptional<z.ZodString>;
                        dq: z.ZodOptional<z.ZodString>;
                        ext: z.ZodOptional<z.ZodBoolean>;
                        k: z.ZodOptional<z.ZodString>;
                        key_ops: z.ZodOptional<z.ZodString>;
                        kid: z.ZodOptional<z.ZodString>;
                        oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">>, "many">>;
                        p: z.ZodOptional<z.ZodString>;
                        q: z.ZodOptional<z.ZodString>;
                        qi: z.ZodOptional<z.ZodString>;
                        use: z.ZodOptional<z.ZodString>;
                        x5c: z.ZodOptional<z.ZodString>;
                        x5t: z.ZodOptional<z.ZodString>;
                        'x5t#S256': z.ZodOptional<z.ZodString>;
                        x5u: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        kty: z.ZodString;
                        crv: z.ZodOptional<z.ZodString>;
                        x: z.ZodOptional<z.ZodString>;
                        y: z.ZodOptional<z.ZodString>;
                        e: z.ZodOptional<z.ZodString>;
                        n: z.ZodOptional<z.ZodString>;
                        alg: z.ZodOptional<z.ZodString>;
                        d: z.ZodOptional<z.ZodString>;
                        dp: z.ZodOptional<z.ZodString>;
                        dq: z.ZodOptional<z.ZodString>;
                        ext: z.ZodOptional<z.ZodBoolean>;
                        k: z.ZodOptional<z.ZodString>;
                        key_ops: z.ZodOptional<z.ZodString>;
                        kid: z.ZodOptional<z.ZodString>;
                        oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">>, "many">>;
                        p: z.ZodOptional<z.ZodString>;
                        q: z.ZodOptional<z.ZodString>;
                        qi: z.ZodOptional<z.ZodString>;
                        use: z.ZodOptional<z.ZodString>;
                        x5c: z.ZodOptional<z.ZodString>;
                        x5t: z.ZodOptional<z.ZodString>;
                        'x5t#S256': z.ZodOptional<z.ZodString>;
                        x5u: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        kty: z.ZodString;
                        crv: z.ZodOptional<z.ZodString>;
                        x: z.ZodOptional<z.ZodString>;
                        y: z.ZodOptional<z.ZodString>;
                        e: z.ZodOptional<z.ZodString>;
                        n: z.ZodOptional<z.ZodString>;
                        alg: z.ZodOptional<z.ZodString>;
                        d: z.ZodOptional<z.ZodString>;
                        dp: z.ZodOptional<z.ZodString>;
                        dq: z.ZodOptional<z.ZodString>;
                        ext: z.ZodOptional<z.ZodBoolean>;
                        k: z.ZodOptional<z.ZodString>;
                        key_ops: z.ZodOptional<z.ZodString>;
                        kid: z.ZodOptional<z.ZodString>;
                        oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                            d: z.ZodOptional<z.ZodString>;
                            r: z.ZodOptional<z.ZodString>;
                            t: z.ZodOptional<z.ZodString>;
                        }, z.ZodTypeAny, "passthrough">>, "many">>;
                        p: z.ZodOptional<z.ZodString>;
                        q: z.ZodOptional<z.ZodString>;
                        qi: z.ZodOptional<z.ZodString>;
                        use: z.ZodOptional<z.ZodString>;
                        x5c: z.ZodOptional<z.ZodString>;
                        x5t: z.ZodOptional<z.ZodString>;
                        'x5t#S256': z.ZodOptional<z.ZodString>;
                        x5u: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>>;
                    jkt: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                status: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodAny>>;
            }, z.ZodTypeAny, "passthrough">;
            signer: _openid4vc_oauth2.JwtSignerWithJwk;
        } | undefined;
    }>;
    /**
     * @throws Oauth2ServerErrorResponseError - if verification of the key attestation failed. You can extract
     *  the credential error response from this.
     */
    verifyCredentialRequestAttestationProof(options: Pick<VerifyCredentialRequestAttestationProofOptions, 'keyAttestationJwt' | 'expectedNonce' | 'nonceExpiresAt' | 'now'> & {
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        header: z.objectOutputType<{
            typ: z.ZodLiteral<"keyattestation+jwt">;
            alg: z.ZodEffects<z.ZodString, string, string>;
            kid: z.ZodOptional<z.ZodString>;
            jwk: z.ZodOptional<z.ZodObject<{
                kty: z.ZodString;
                crv: z.ZodOptional<z.ZodString>;
                x: z.ZodOptional<z.ZodString>;
                y: z.ZodOptional<z.ZodString>;
                e: z.ZodOptional<z.ZodString>;
                n: z.ZodOptional<z.ZodString>;
                alg: z.ZodOptional<z.ZodString>;
                d: z.ZodOptional<z.ZodString>;
                dp: z.ZodOptional<z.ZodString>;
                dq: z.ZodOptional<z.ZodString>;
                ext: z.ZodOptional<z.ZodBoolean>;
                k: z.ZodOptional<z.ZodString>;
                key_ops: z.ZodOptional<z.ZodString>;
                kid: z.ZodOptional<z.ZodString>;
                oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
                p: z.ZodOptional<z.ZodString>;
                q: z.ZodOptional<z.ZodString>;
                qi: z.ZodOptional<z.ZodString>;
                use: z.ZodOptional<z.ZodString>;
                x5c: z.ZodOptional<z.ZodString>;
                x5t: z.ZodOptional<z.ZodString>;
                'x5t#S256': z.ZodOptional<z.ZodString>;
                x5u: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                kty: z.ZodString;
                crv: z.ZodOptional<z.ZodString>;
                x: z.ZodOptional<z.ZodString>;
                y: z.ZodOptional<z.ZodString>;
                e: z.ZodOptional<z.ZodString>;
                n: z.ZodOptional<z.ZodString>;
                alg: z.ZodOptional<z.ZodString>;
                d: z.ZodOptional<z.ZodString>;
                dp: z.ZodOptional<z.ZodString>;
                dq: z.ZodOptional<z.ZodString>;
                ext: z.ZodOptional<z.ZodBoolean>;
                k: z.ZodOptional<z.ZodString>;
                key_ops: z.ZodOptional<z.ZodString>;
                kid: z.ZodOptional<z.ZodString>;
                oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
                p: z.ZodOptional<z.ZodString>;
                q: z.ZodOptional<z.ZodString>;
                qi: z.ZodOptional<z.ZodString>;
                use: z.ZodOptional<z.ZodString>;
                x5c: z.ZodOptional<z.ZodString>;
                x5t: z.ZodOptional<z.ZodString>;
                'x5t#S256': z.ZodOptional<z.ZodString>;
                x5u: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                kty: z.ZodString;
                crv: z.ZodOptional<z.ZodString>;
                x: z.ZodOptional<z.ZodString>;
                y: z.ZodOptional<z.ZodString>;
                e: z.ZodOptional<z.ZodString>;
                n: z.ZodOptional<z.ZodString>;
                alg: z.ZodOptional<z.ZodString>;
                d: z.ZodOptional<z.ZodString>;
                dp: z.ZodOptional<z.ZodString>;
                dq: z.ZodOptional<z.ZodString>;
                ext: z.ZodOptional<z.ZodBoolean>;
                k: z.ZodOptional<z.ZodString>;
                key_ops: z.ZodOptional<z.ZodString>;
                kid: z.ZodOptional<z.ZodString>;
                oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
                p: z.ZodOptional<z.ZodString>;
                q: z.ZodOptional<z.ZodString>;
                qi: z.ZodOptional<z.ZodString>;
                use: z.ZodOptional<z.ZodString>;
                x5c: z.ZodOptional<z.ZodString>;
                x5t: z.ZodOptional<z.ZodString>;
                'x5t#S256': z.ZodOptional<z.ZodString>;
                x5u: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>>;
            x5c: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
            trust_chain: z.ZodOptional<z.ZodArray<z.ZodString, "many">>;
        }, z.ZodTypeAny, "passthrough">;
        payload: z.objectOutputType<{
            nonce: z.ZodString | z.ZodOptional<z.ZodString>;
            exp: z.ZodNumber | z.ZodOptional<z.ZodNumber>;
            iat: z.ZodNumber;
            attested_keys: z.ZodArray<z.ZodObject<{
                kty: z.ZodString;
                crv: z.ZodOptional<z.ZodString>;
                x: z.ZodOptional<z.ZodString>;
                y: z.ZodOptional<z.ZodString>;
                e: z.ZodOptional<z.ZodString>;
                n: z.ZodOptional<z.ZodString>;
                alg: z.ZodOptional<z.ZodString>;
                d: z.ZodOptional<z.ZodString>;
                dp: z.ZodOptional<z.ZodString>;
                dq: z.ZodOptional<z.ZodString>;
                ext: z.ZodOptional<z.ZodBoolean>;
                k: z.ZodOptional<z.ZodString>;
                key_ops: z.ZodOptional<z.ZodString>;
                kid: z.ZodOptional<z.ZodString>;
                oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
                p: z.ZodOptional<z.ZodString>;
                q: z.ZodOptional<z.ZodString>;
                qi: z.ZodOptional<z.ZodString>;
                use: z.ZodOptional<z.ZodString>;
                x5c: z.ZodOptional<z.ZodString>;
                x5t: z.ZodOptional<z.ZodString>;
                'x5t#S256': z.ZodOptional<z.ZodString>;
                x5u: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                kty: z.ZodString;
                crv: z.ZodOptional<z.ZodString>;
                x: z.ZodOptional<z.ZodString>;
                y: z.ZodOptional<z.ZodString>;
                e: z.ZodOptional<z.ZodString>;
                n: z.ZodOptional<z.ZodString>;
                alg: z.ZodOptional<z.ZodString>;
                d: z.ZodOptional<z.ZodString>;
                dp: z.ZodOptional<z.ZodString>;
                dq: z.ZodOptional<z.ZodString>;
                ext: z.ZodOptional<z.ZodBoolean>;
                k: z.ZodOptional<z.ZodString>;
                key_ops: z.ZodOptional<z.ZodString>;
                kid: z.ZodOptional<z.ZodString>;
                oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
                p: z.ZodOptional<z.ZodString>;
                q: z.ZodOptional<z.ZodString>;
                qi: z.ZodOptional<z.ZodString>;
                use: z.ZodOptional<z.ZodString>;
                x5c: z.ZodOptional<z.ZodString>;
                x5t: z.ZodOptional<z.ZodString>;
                'x5t#S256': z.ZodOptional<z.ZodString>;
                x5u: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                kty: z.ZodString;
                crv: z.ZodOptional<z.ZodString>;
                x: z.ZodOptional<z.ZodString>;
                y: z.ZodOptional<z.ZodString>;
                e: z.ZodOptional<z.ZodString>;
                n: z.ZodOptional<z.ZodString>;
                alg: z.ZodOptional<z.ZodString>;
                d: z.ZodOptional<z.ZodString>;
                dp: z.ZodOptional<z.ZodString>;
                dq: z.ZodOptional<z.ZodString>;
                ext: z.ZodOptional<z.ZodBoolean>;
                k: z.ZodOptional<z.ZodString>;
                key_ops: z.ZodOptional<z.ZodString>;
                kid: z.ZodOptional<z.ZodString>;
                oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    d: z.ZodOptional<z.ZodString>;
                    r: z.ZodOptional<z.ZodString>;
                    t: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>, "many">>;
                p: z.ZodOptional<z.ZodString>;
                q: z.ZodOptional<z.ZodString>;
                qi: z.ZodOptional<z.ZodString>;
                use: z.ZodOptional<z.ZodString>;
                x5c: z.ZodOptional<z.ZodString>;
                x5t: z.ZodOptional<z.ZodString>;
                'x5t#S256': z.ZodOptional<z.ZodString>;
                x5u: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>, "many">;
            key_storage: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
            user_authentication: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodEnum<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"]>, z.ZodString]>, "many">>;
            certification: z.ZodOptional<z.ZodString>;
            iss: z.ZodOptional<z.ZodString>;
            aud: z.ZodOptional<z.ZodString>;
            nbf: z.ZodOptional<z.ZodNumber>;
            jti: z.ZodOptional<z.ZodString>;
            cnf: z.ZodOptional<z.ZodObject<{
                jwk: z.ZodOptional<z.ZodObject<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                jkt: z.ZodOptional<z.ZodString>;
            }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                jwk: z.ZodOptional<z.ZodObject<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                jkt: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                jwk: z.ZodOptional<z.ZodObject<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                    kty: z.ZodString;
                    crv: z.ZodOptional<z.ZodString>;
                    x: z.ZodOptional<z.ZodString>;
                    y: z.ZodOptional<z.ZodString>;
                    e: z.ZodOptional<z.ZodString>;
                    n: z.ZodOptional<z.ZodString>;
                    alg: z.ZodOptional<z.ZodString>;
                    d: z.ZodOptional<z.ZodString>;
                    dp: z.ZodOptional<z.ZodString>;
                    dq: z.ZodOptional<z.ZodString>;
                    ext: z.ZodOptional<z.ZodBoolean>;
                    k: z.ZodOptional<z.ZodString>;
                    key_ops: z.ZodOptional<z.ZodString>;
                    kid: z.ZodOptional<z.ZodString>;
                    oth: z.ZodOptional<z.ZodArray<z.ZodObject<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, "passthrough", z.ZodTypeAny, z.objectOutputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">, z.objectInputType<{
                        d: z.ZodOptional<z.ZodString>;
                        r: z.ZodOptional<z.ZodString>;
                        t: z.ZodOptional<z.ZodString>;
                    }, z.ZodTypeAny, "passthrough">>, "many">>;
                    p: z.ZodOptional<z.ZodString>;
                    q: z.ZodOptional<z.ZodString>;
                    qi: z.ZodOptional<z.ZodString>;
                    use: z.ZodOptional<z.ZodString>;
                    x5c: z.ZodOptional<z.ZodString>;
                    x5t: z.ZodOptional<z.ZodString>;
                    'x5t#S256': z.ZodOptional<z.ZodString>;
                    x5u: z.ZodOptional<z.ZodString>;
                }, z.ZodTypeAny, "passthrough">>>;
                jkt: z.ZodOptional<z.ZodString>;
            }, z.ZodTypeAny, "passthrough">>>;
            status: z.ZodOptional<z.ZodRecord<z.ZodString, z.ZodAny>>;
        }, z.ZodTypeAny, "passthrough">;
        signer: _openid4vc_oauth2.JwtSignerWithJwk;
    }>;
    /**
     * @throws Oauth2ServerErrorResponseError - when validation of the credential request fails
     *  You can extract the credential error response from this.
     */
    parseCredentialRequest(options: ParseCredentialRequestOptions): ParseCredentialRequestReturn;
    /**
     * @throws ValidationError - when validation of the credential response fails
     */
    createCredentialResponse(options: CreateCredentialResponseOptions): z.objectOutputType<{
        credential: z.ZodOptional<z.ZodUnion<[z.ZodString, z.ZodRecord<z.ZodString, z.ZodAny>]>>;
        credentials: z.ZodOptional<z.ZodArray<z.ZodUnion<[z.ZodString, z.ZodRecord<z.ZodString, z.ZodAny>]>, "many">>;
        transaction_id: z.ZodOptional<z.ZodString>;
        c_nonce: z.ZodOptional<z.ZodString>;
        c_nonce_expires_in: z.ZodOptional<z.ZodNumber>;
        notification_id: z.ZodOptional<z.ZodString>;
    }, z.ZodTypeAny, "passthrough">;
    /**
     * @throws ValidationError - when validation of the nonce response fails
     */
    createNonceResponse(options: CreateNonceResponseOptions): z.objectOutputType<{
        c_nonce: z.ZodString;
        c_nonce_expires_in: z.ZodOptional<z.ZodNumber>;
    }, z.ZodTypeAny, "passthrough">;
}

export { AuthorizationFlow, type CredenialOfferAuthorizationCodeGrant, type CredentialConfigurationSupported, type CredentialConfigurationSupportedWithFormats, type CredentialConfigurationsSupported, type CredentialConfigurationsSupportedWithFormats, type CredentialErrorResponse, type CredentialFormatIdentifier, type CredentialIssuerMetadata, type CredentialIssuerMetadataDisplayEntry, type CredentialOfferGrants, type CredentialOfferObject, type CredentialOfferPreAuthorizedCodeGrant, type CredentialOfferPreAuthorizedCodeGrantTxCode, type CredentialRequest, type CredentialRequestFormatSpecific, type CredentialRequestJwtProofTypeHeader, type CredentialRequestJwtProofTypePayload, type CredentialRequestWithFormats, type CredentialResponse, type ExtractScopesForCredentialConfigurationIdsOptions, type GetCredentialConfigurationsMatchingRequestFormatOptions, type IssuerMetadataResult, type JwtProofTypeIdentifier, type JwtVcJsonFormatIdentifier, type JwtVcJsonLdFormatIdentifier, type LdpVcFormatIdentifier, type MsoMdocFormatIdentifier, type NonceResponse, type NotificationErrorResponse, type NotificationEvent, Oid4vciClient, type Oid4vciClientOptions, Oid4vciDraftVersion, Oid4vciError, type Oid4vciErrorOptions, Oid4vciIssuer, type Oid4vciIssuerOptions, Oid4vciRetrieveCredentialsError, Oid4vciSendNotificationError, type ParseCredentialRequestReturn, type ProofTypeIdentifier, type RetrieveCredentialsResponseNotOk, type RetrieveCredentialsResponseOk, type SdJwtVcFormatIdentifier, type SendNotificationResponseNotOk, type SendNotificationResponseOk, credentialsSupportedToCredentialConfigurationsSupported, extractScopesForCredentialConfigurationIds, getCredentialConfigurationsMatchingRequestFormat };
